import hppfcl
import typing

__all__ = [
    "AABB",
    "AngleAxis",
    "BVHBuildState",
    "BVHModelBase",
    "BVHModelOBB",
    "BVHModelOBBRSS",
    "BVHModelType",
    "BVH_BUILD_STATE_BEGUN",
    "BVH_BUILD_STATE_EMPTY",
    "BVH_BUILD_STATE_PROCESSED",
    "BVH_BUILD_STATE_REPLACE_BEGUN",
    "BVH_BUILD_STATE_UPDATED",
    "BVH_BUILD_STATE_UPDATE_BEGUN",
    "BVH_MODEL_POINTCLOUD",
    "BVH_MODEL_TRIANGLES",
    "BVH_MODEL_UNKNOWN",
    "BV_AABB",
    "BV_KDOP16",
    "BV_KDOP18",
    "BV_KDOP24",
    "BV_OBB",
    "BV_OBBRSS",
    "BV_RSS",
    "BV_UNKNOWN",
    "BV_kIOS",
    "Box",
    "CONTACT",
    "CPUTimes",
    "CachedMeshLoader",
    "Capsule",
    "CollisionGeometry",
    "CollisionObject",
    "CollisionRequest",
    "CollisionRequestFlag",
    "CollisionResult",
    "ComputeCollision",
    "ComputeDistance",
    "Cone",
    "Contact",
    "Convex",
    "ConvexBase",
    "Cylinder",
    "DISTANCE_LOWER_BOUND",
    "DistanceRequest",
    "DistanceResult",
    "Exception",
    "Failed",
    "GEOM_BOX",
    "GEOM_CAPSULE",
    "GEOM_CONE",
    "GEOM_CONVEX",
    "GEOM_CYLINDER",
    "GEOM_HALFSPACE",
    "GEOM_OCTREE",
    "GEOM_PLANE",
    "GEOM_SPHERE",
    "GEOM_TRIANGLE",
    "GJK",
    "GJKStatus",
    "HF_AABB",
    "HF_OBBRSS",
    "HPP_FCL_MAJOR_VERSION",
    "HPP_FCL_MINOR_VERSION",
    "HPP_FCL_PATCH_VERSION",
    "Halfspace",
    "HeightFieldAABB",
    "HeightFieldOBBRSS",
    "Inside",
    "MeshLoader",
    "MinkowskiDiff",
    "NODE_TYPE",
    "NO_REQUEST",
    "OBJECT_TYPE",
    "OT_BVH",
    "OT_GEOM",
    "OT_HFIELD",
    "OT_OCTREE",
    "OT_UNKNOWN",
    "OcTree",
    "Plane",
    "Quaternion",
    "QueryRequest",
    "QueryResult",
    "ShapeBase",
    "Sphere",
    "StdVec_CollisionRequest",
    "StdVec_CollisionResult",
    "StdVec_Contact",
    "StdVec_DistanceRequest",
    "StdVec_DistanceResult",
    "StdVec_Triangle",
    "StdVec_Vec3f",
    "Transform3f",
    "Triangle",
    "TriangleP",
    "Valid",
    "checkVersionAtLeast",
    "checkVersionAtMost",
    "collide",
    "computeMemoryFootprint",
    "distance",
    "getNumpyType",
    "hppfcl",
    "makeOctree",
    "rotate",
    "seed",
    "setNumpyType",
    "sharedMemory",
    "switchToNumpyArray",
    "switchToNumpyMatrix",
    "translate"
]

class AABB(Boost.Python.instance):
    """
    A class describing the AABB collision structure, which is a box in 3D space determined by two diagonal points
    """
    @staticmethod
    def __add__(arg1: AABB, arg2: AABB) -> object: 
        """
        __add__( (AABB)arg1, (AABB)arg2) -> object :

            C++ signature :
                _object* __add__(hpp::fcl::AABB {lvalue},hpp::fcl::AABB)
        """
    @staticmethod
    @typing.overload
    def __iadd__(arg1: object, arg2: AABB) -> object: 
        """
        __iadd__( (object)arg1, (AABB)arg2) -> object :

            C++ signature :
                _object* __iadd__(boost::python::back_reference<hpp::fcl::AABB&>,hpp::fcl::AABB)

            C++ signature :
                _object* __iadd__(boost::python::back_reference<hpp::fcl::AABB&>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @staticmethod
    @typing.overload
    def __iadd__(arg1: object, arg2: object) -> object: ...
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :
            Default constructor

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 1, 0, 3, 1>)

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)

            C++ signature :
                void __init__(_object*,hpp::fcl::AABB,Eigen::Matrix<double, 3, 1, 0, 3, 1>)

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @typing.overload
    def __init__(self, a: object, b: object) -> None: ...
    @typing.overload
    def __init__(self, a: object, b: object, c: object) -> None: ...
    @typing.overload
    def __init__(self, core: AABB, delta: object) -> None: ...
    @typing.overload
    def __init__(self, v: object) -> None: ...
    def center(self) -> object: 
        """
        center( (AABB)self) -> object :
            Center of the AABB.

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> center(hpp::fcl::AABB {lvalue})
        """
    @typing.overload
    def contain(self, other: AABB) -> bool: 
        """
        contain( (AABB)self, (object)p) -> bool :
            Check whether the AABB contains a point p.

            C++ signature :
                bool contain(hpp::fcl::AABB {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>)

            C++ signature :
                bool contain(hpp::fcl::AABB {lvalue},hpp::fcl::AABB)
        """
    @typing.overload
    def contain(self, p: object) -> bool: ...
    def depth(self) -> float: 
        """
        depth( (AABB)self) -> float :
            Depth of the AABB.

            C++ signature :
                double depth(hpp::fcl::AABB {lvalue})
        """
    def distance(self, other: AABB) -> float: 
        """
        distance( (AABB)self, (AABB)other) -> float :
            Distance between two AABBs.

            C++ signature :
                double distance(hpp::fcl::AABB {lvalue},hpp::fcl::AABB)
        """
    @typing.overload
    def expand(self, core: AABB, ratio: float) -> AABB: 
        """
        expand( (AABB)self, (AABB)core, (float)ratio) -> AABB :
            Expand the AABB by increase the thickness of the plate by a ratio.

            C++ signature :
                hpp::fcl::AABB {lvalue} expand(hpp::fcl::AABB {lvalue},hpp::fcl::AABB,double)

            C++ signature :
                hpp::fcl::AABB {lvalue} expand(hpp::fcl::AABB {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @typing.overload
    def expand(self, delta: object) -> AABB: ...
    def height(self) -> float: 
        """
        height( (AABB)self) -> float :
            Height of the AABB.

            C++ signature :
                double height(hpp::fcl::AABB {lvalue})
        """
    @typing.overload
    def overlap(self, other: AABB) -> bool: 
        """
        overlap( (AABB)self, (AABB)other) -> bool :
            Check whether two AABB are overlap.

            C++ signature :
                bool overlap(hpp::fcl::AABB {lvalue},hpp::fcl::AABB)

            C++ signature :
                bool overlap(hpp::fcl::AABB {lvalue},hpp::fcl::AABB,hpp::fcl::AABB {lvalue})
        """
    @typing.overload
    def overlap(self, other: AABB, overlapping_part: AABB) -> bool: ...
    def size(self) -> float: 
        """
        size( (AABB)self) -> float :
            Size of the AABB.

            C++ signature :
                double size(hpp::fcl::AABB {lvalue})
        """
    def volume(self) -> float: 
        """
        volume( (AABB)self) -> float :
            Volume of the AABB.

            C++ signature :
                double volume(hpp::fcl::AABB {lvalue})
        """
    def width(self) -> float: 
        """
        width( (AABB)self) -> float :
            Width of the AABB.

            C++ signature :
                double width(hpp::fcl::AABB {lvalue})
        """
    pass

class AngleAxis(Boost.Python.instance):
    """
    AngleAxis representation of a rotation.
    """
    @staticmethod
    def __eq__(arg1: AngleAxis, arg2: AngleAxis) -> bool: 
        """
        __eq__( (AngleAxis)arg1, (AngleAxis)arg2) -> bool :

            C++ signature :
                bool __eq__(Eigen::AngleAxis<double>,Eigen::AngleAxis<double>)
        """
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :
            Default constructor

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,double,Eigen::Matrix<double, 3, 1, 0, 3, 1>)

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 3, 0, 3, 3>)

            C++ signature :
                void __init__(_object*,Eigen::Quaternion<double, 0>)

            C++ signature :
                void __init__(_object*,Eigen::AngleAxis<double>)
        """
    @typing.overload
    def __init__(self, angle: float, axis: object) -> None: ...
    @typing.overload
    def __init__(self, copy: AngleAxis) -> None: ...
    @typing.overload
    def __init__(self, quaternion: Quaternion) -> None: ...
    @typing.overload
    def __init__(self, rotation_matrix: object) -> None: ...
    @staticmethod
    @typing.overload
    def __mul__(arg1: AngleAxis, arg2: AngleAxis) -> object: 
        """
        __mul__( (AngleAxis)arg1, (object)arg2) -> object :

            C++ signature :
                _object* __mul__(Eigen::AngleAxis<double> {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>)

            C++ signature :
                _object* __mul__(Eigen::AngleAxis<double> {lvalue},Eigen::Quaternion<double, 0>)

            C++ signature :
                _object* __mul__(Eigen::AngleAxis<double> {lvalue},Eigen::AngleAxis<double>)
        """
    @staticmethod
    @typing.overload
    def __mul__(arg1: AngleAxis, arg2: Quaternion) -> object: ...
    @staticmethod
    @typing.overload
    def __mul__(arg1: AngleAxis, arg2: object) -> object: ...
    @staticmethod
    def __ne__(arg1: AngleAxis, arg2: AngleAxis) -> bool: 
        """
        __ne__( (AngleAxis)arg1, (AngleAxis)arg2) -> bool :

            C++ signature :
                bool __ne__(Eigen::AngleAxis<double>,Eigen::AngleAxis<double>)
        """
    @staticmethod
    def __repr__(arg1: AngleAxis) -> str: 
        """
        __repr__( (AngleAxis)arg1) -> str :

            C++ signature :
                std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> > __repr__(Eigen::AngleAxis<double>)
        """
    @staticmethod
    def __str__(arg1: AngleAxis) -> str: 
        """
        __str__( (AngleAxis)arg1) -> str :

            C++ signature :
                std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> > __str__(Eigen::AngleAxis<double>)
        """
    def fromRotationMatrix(self, rotation_matrix: object) -> AngleAxis: 
        """
        fromRotationMatrix( (AngleAxis)self, (object)rotation matrix) -> AngleAxis :
            Sets *this from a 3x3 rotation matrix

            C++ signature :
                Eigen::AngleAxis<double> {lvalue} fromRotationMatrix(Eigen::AngleAxis<double> {lvalue},Eigen::MatrixBase<Eigen::Matrix<double, 3, 3, 0, 3, 3> >)
        """
    def inverse(self) -> AngleAxis: 
        """
        inverse( (AngleAxis)self) -> AngleAxis :
            Return the inverse rotation.

            C++ signature :
                Eigen::AngleAxis<double> inverse(Eigen::AngleAxis<double> {lvalue})
        """
    def isApprox(self, other_: AngleAxis, prec: float) -> bool: 
        """
        isApprox( (AngleAxis)self, (AngleAxis)other [, (float)prec]) -> bool :
            Returns true if *this is approximately equal to other, within the precision determined by prec.

            C++ signature :
                bool isApprox(Eigen::AngleAxis<double>,Eigen::AngleAxis<double> [,double])
        """
    def matrix(self) -> object: 
        """
        matrix( (AngleAxis)self) -> object :
            Returns an equivalent rotation matrix.

            C++ signature :
                Eigen::Matrix<double, 3, 3, 0, 3, 3> matrix(Eigen::AngleAxis<double> {lvalue})
        """
    @staticmethod
    def toRotationMatrix(arg1: AngleAxis) -> object: 
        """
        toRotationMatrix( (AngleAxis)arg1) -> object :
            Constructs and returns an equivalent 3x3 rotation matrix.

            C++ signature :
                Eigen::Matrix<double, 3, 3, 0, 3, 3> toRotationMatrix(Eigen::AngleAxis<double> {lvalue})
        """
    @property
    def angle(self) -> None:
        """
        The rotation angle.

        :type: None
        """
    @property
    def axis(self) -> None:
        """
        The rotation axis.

        :type: None
        """
    pass

class CollisionGeometry(Boost.Python.instance):
    @staticmethod
    def computeCOM(arg1: CollisionGeometry) -> object: 
        """
        computeCOM( (CollisionGeometry)arg1) -> object :

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> computeCOM(hpp::fcl::CollisionGeometry {lvalue})
        """
    @staticmethod
    def computeLocalAABB(arg1: CollisionGeometry) -> None: 
        """
        computeLocalAABB( (CollisionGeometry)arg1) -> None :

            C++ signature :
                void computeLocalAABB(hpp::fcl::CollisionGeometry {lvalue})
        """
    @staticmethod
    def computeMomentofInertia(arg1: CollisionGeometry) -> object: 
        """
        computeMomentofInertia( (CollisionGeometry)arg1) -> object :

            C++ signature :
                Eigen::Matrix<double, 3, 3, 0, 3, 3> computeMomentofInertia(hpp::fcl::CollisionGeometry {lvalue})
        """
    @staticmethod
    def computeMomentofInertiaRelatedToCOM(arg1: CollisionGeometry) -> object: 
        """
        computeMomentofInertiaRelatedToCOM( (CollisionGeometry)arg1) -> object :

            C++ signature :
                Eigen::Matrix<double, 3, 3, 0, 3, 3> computeMomentofInertiaRelatedToCOM(hpp::fcl::CollisionGeometry {lvalue})
        """
    @staticmethod
    def computeVolume(arg1: CollisionGeometry) -> float: 
        """
        computeVolume( (CollisionGeometry)arg1) -> float :

            C++ signature :
                double computeVolume(hpp::fcl::CollisionGeometry {lvalue})
        """
    @staticmethod
    def getNodeType(arg1: CollisionGeometry) -> NODE_TYPE: 
        """
        getNodeType( (CollisionGeometry)arg1) -> NODE_TYPE :

            C++ signature :
                hpp::fcl::NODE_TYPE getNodeType(hpp::fcl::CollisionGeometry {lvalue})
        """
    @staticmethod
    def getObjectType(arg1: CollisionGeometry) -> OBJECT_TYPE: 
        """
        getObjectType( (CollisionGeometry)arg1) -> OBJECT_TYPE :

            C++ signature :
                hpp::fcl::OBJECT_TYPE getObjectType(hpp::fcl::CollisionGeometry {lvalue})
        """
    def isFree(self) -> bool: 
        """
        isFree( (CollisionGeometry)self) -> bool :
            Whether the object is completely free.

            C++ signature :
                bool isFree(hpp::fcl::CollisionGeometry {lvalue})
        """
    def isOccupied(self) -> bool: 
        """
        isOccupied( (CollisionGeometry)self) -> bool :
            Whether the object is completely occupied.

            C++ signature :
                bool isOccupied(hpp::fcl::CollisionGeometry {lvalue})
        """
    def isUncertain(self) -> bool: 
        """
        isUncertain( (CollisionGeometry)self) -> bool :
            Whether the object has some uncertainty.

            C++ signature :
                bool isUncertain(hpp::fcl::CollisionGeometry {lvalue})
        """
    @property
    def aabb_center(self) -> None:
        """
        AABB center in local coordinate.

        :type: None
        """
    @property
    def aabb_local(self) -> None:
        """
        AABB in local coordinate, used for tight AABB when only translation transform.

        :type: None
        """
    @property
    def aabb_radius(self) -> None:
        """
        AABB radius.

        :type: None
        """
    @property
    def cost_density(self) -> None:
        """
        Collision cost for unit volume.

        :type: None
        """
    @property
    def threshold_free(self) -> None:
        """
        Threshold for free (<= is free).

        :type: None
        """
    @property
    def threshold_occupied(self) -> None:
        """
        Threshold for occupied ( >= is occupied).

        :type: None
        """
    pass

class BVHModelBase(CollisionGeometry, Boost.Python.instance):
    @typing.overload
    def addSubModel(self, ps: StdVec_Vec3f) -> int: 
        """
        addSubModel( (BVHModelBase)self, (StdVec_Vec3f)ps, (StdVec_Triangle)ts) -> int :
            Add a set of triangles in the new BVH model. 

            C++ signature :
                int addSubModel(hpp::fcl::BVHModelBase {lvalue},std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > >,std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> >)

            C++ signature :
                int addSubModel(hpp::fcl::BVHModelBase {lvalue},std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > >)
        """
    @typing.overload
    def addSubModel(self, ps: StdVec_Vec3f, ts: StdVec_Triangle) -> int: ...
    def addTriangle(self, p1: object, p2: object, p3: object) -> int: 
        """
        addTriangle( (BVHModelBase)self, (object)p1, (object)p2, (object)p3) -> int :
            Add one triangle in the new BVH model. 

            C++ signature :
                int addTriangle(hpp::fcl::BVHModelBase {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    def addTriangles(self, triangles: object) -> int: 
        """
        addTriangles( (BVHModelBase)self, (object)triangles) -> int :
            Add triangles in the new BVH model. 

            C++ signature :
                int addTriangles(hpp::fcl::BVHModelBase {lvalue},Eigen::Matrix<long, -1, 3, 0, -1, 3>)
        """
    def addVertex(self, p: object) -> int: 
        """
        addVertex( (BVHModelBase)self, (object)p) -> int :
            Add one point in the new BVH model. 

            C++ signature :
                int addVertex(hpp::fcl::BVHModelBase {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    def addVertices(self, points: object) -> int: 
        """
        addVertices( (BVHModelBase)self, (object)points) -> int :
            Add points in the new BVH model. 

            C++ signature :
                int addVertices(hpp::fcl::BVHModelBase {lvalue},Eigen::Matrix<double, -1, 3, 0, -1, 3>)
        """
    def beginModel(self, num_tris: int, num_vertices: int) -> int: 
        """
        beginModel( (BVHModelBase)self, (int)num_tris, (int)num_vertices) -> int :
            Begin a new BVH model. 

            C++ signature :
                int beginModel(hpp::fcl::BVHModelBase {lvalue},unsigned int,unsigned int)
        """
    def beginReplaceModel(self) -> int: 
        """
        beginReplaceModel( (BVHModelBase)self) -> int :
            Replace the geometry information of current frame (i.e. should have the same mesh topology with the previous frame) 

            C++ signature :
                int beginReplaceModel(hpp::fcl::BVHModelBase {lvalue})
        """
    def buildConvexHull(self, keepTriangle: bool, qhullCommand: str) -> bool: 
        """
        buildConvexHull( (BVHModelBase)self, (bool)keepTriangle, (str)qhullCommand) -> bool :
            Build a convex hull and store it in attribute convex. 
            
            
            Param
              - keepTriangle whether the convex should be triangulated. 
              - qhullCommand see ConvexBase::convexHull. 
            
            Return: true if this object is convex, hence the convex hull represents the same object. 
            
            See: ConvexBase::convexHull 
            
            Warning: At the moment, the return value only checks whether there are as many points in the convex hull as in the original object. This is neither necessary (duplicated vertices get merged) nor sufficient (think of a U with 4 vertices and 3 edges). 

            C++ signature :
                bool buildConvexHull(hpp::fcl::BVHModelBase {lvalue},bool,char const*)
        """
    def buildConvexRepresentation(self, share_memory: bool) -> None: 
        """
        buildConvexRepresentation( (BVHModelBase)self, (bool)share_memory) -> None :
            Build this hpp::fcl::Convex representation of this model. The result is stored in attribute convex. 
            
            Note: this only takes the points of this model. It does not check that the object is convex. It does not compute a convex hull. 

            C++ signature :
                void buildConvexRepresentation(hpp::fcl::BVHModelBase {lvalue},bool)
        """
    def endModel(self) -> int: 
        """
        endModel( (BVHModelBase)self) -> int :
            End BVH model construction, will build the bounding volume hierarchy. 

            C++ signature :
                int endModel(hpp::fcl::BVHModelBase {lvalue})
        """
    def endReplaceModel(self, refit: bool, bottomup: bool) -> int: 
        """
        endReplaceModel( (BVHModelBase)self, (bool)refit, (bool)bottomup) -> int :
            End BVH model replacement, will also refit or rebuild the bounding volume hierarchy. 

            C++ signature :
                int endReplaceModel(hpp::fcl::BVHModelBase {lvalue},bool,bool)
        """
    def getModelType(self) -> BVHModelType: 
        """
        getModelType( (BVHModelBase)self) -> BVHModelType :
            Model type described by the instance. 

            C++ signature :
                hpp::fcl::BVHModelType getModelType(hpp::fcl::BVHModelBase {lvalue})
        """
    def replaceSubModel(self, ps: StdVec_Vec3f) -> int: 
        """
        replaceSubModel( (BVHModelBase)self, (StdVec_Vec3f)ps) -> int :
            Replace a set of points in the old BVH model. 

            C++ signature :
                int replaceSubModel(hpp::fcl::BVHModelBase {lvalue},std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > >)
        """
    def replaceTriangle(self, p1: object, p2: object, p3: object) -> int: 
        """
        replaceTriangle( (BVHModelBase)self, (object)p1, (object)p2, (object)p3) -> int :
            Replace one triangle in the old BVH model. 

            C++ signature :
                int replaceTriangle(hpp::fcl::BVHModelBase {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    def replaceVertex(self, p: object) -> int: 
        """
        replaceVertex( (BVHModelBase)self, (object)p) -> int :
            Replace one point in the old BVH model. 

            C++ signature :
                int replaceVertex(hpp::fcl::BVHModelBase {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    def tri_indices(self, index: int) -> Triangle: 
        """
        tri_indices( (BVHModelBase)self, (int)index) -> Triangle :
            Retrieve the triangle given by its index.

            C++ signature :
                hpp::fcl::Triangle tri_indices(hpp::fcl::BVHModelBase,unsigned int)
        """
    def vertex(self, index: int) -> object: 
        """
        vertex( (BVHModelBase)self, (int)index) -> object :
            Retrieve the vertex given by its index.

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> {lvalue} vertex(hpp::fcl::BVHModelBase {lvalue},unsigned int)
        """
    @typing.overload
    def vertices(self) -> object: 
        """
        vertices( (BVHModelBase)self, (int)index) -> object :
            Retrieve the vertex given by its index.

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> {lvalue} vertices(hpp::fcl::BVHModelBase {lvalue},unsigned int)

            C++ signature :
                Eigen::Ref<Eigen::Matrix<double, -1, 3, 1, -1, 3>, 0, Eigen::OuterStride<-1> > vertices(hpp::fcl::BVHModelBase {lvalue})
        """
    @typing.overload
    def vertices(self, index: int) -> object: ...
    @property
    def build_state(self) -> None:
        """
        :type: None
        """
    @property
    def convex(self) -> None:
        """
        :type: None
        """
    @property
    def num_tris(self) -> None:
        """
        :type: None
        """
    @property
    def num_vertices(self) -> None:
        """
        :type: None
        """
    pass

class BVHModelOBBRSS(BVHModelBase, CollisionGeometry, Boost.Python.instance):
    """
    A class describing the bounding hierarchy of a mesh model or a point cloud model (which is viewed as a degraded version of mesh) 


    Templateparam
      - BV one of the bounding volume class in Bounding volumes. 
    """
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :
            Default constructor to build an empty BVH. 

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,hpp::fcl::BVHModel<hpp::fcl::OBBRSS>)
        """
    @typing.overload
    def __init__(self, other: BVHModelOBBRSS) -> None: ...
    @staticmethod
    def clone(arg1: BVHModelOBBRSS) -> BVHModelOBBRSS: 
        """
        clone( (BVHModelOBBRSS)arg1) -> BVHModelOBBRSS :
            Clone *this into a new hpp::fcl::BVHModel. 

            C++ signature :
                hpp::fcl::BVHModel<hpp::fcl::OBBRSS>* clone(hpp::fcl::BVHModel<hpp::fcl::OBBRSS> {lvalue})
        """
    def getNumBVs(self) -> int: 
        """
        getNumBVs( (BVHModelOBBRSS)self) -> int :
            Get the number of bv in the BVH. 

            C++ signature :
                unsigned int getNumBVs(hpp::fcl::BVHModel<hpp::fcl::OBBRSS> {lvalue})
        """
    def makeParentRelative(self) -> None: 
        """
        makeParentRelative( (BVHModelOBBRSS)self) -> None :
            This is a special acceleration: BVH_model default stores the BV's transform in world coordinate. However, we can also store each BV's transform related to its parent BV node. When traversing the BVH, this can save one matrix transformation. 

            C++ signature :
                void makeParentRelative(hpp::fcl::BVHModel<hpp::fcl::OBBRSS> {lvalue})
        """
    def memUsage(self, msg: bool) -> int: 
        """
        memUsage( (BVHModelOBBRSS)self, (bool)msg) -> int :

            C++ signature :
                int memUsage(hpp::fcl::BVHModel<hpp::fcl::OBBRSS> {lvalue},bool)
        """
    pass

class ShapeBase(CollisionGeometry, Boost.Python.instance):
    """
    Base class for all basic geometric shapes. 
    """
    pass

class CPUTimes(Boost.Python.instance):
    def clear(self) -> None: 
        """
        clear( (CPUTimes)self) -> None :
            Reset the time values.

            C++ signature :
                void clear(hpp::fcl::CPUTimes {lvalue})
        """
    @property
    def system(self) -> None:
        """
        system time in micro seconds (us)

        :type: None
        """
    @property
    def user(self) -> None:
        """
        user time in micro seconds (us)

        :type: None
        """
    @property
    def wall(self) -> None:
        """
        wall time in micro seconds (us)

        :type: None
        """
    pass

class MeshLoader(Boost.Python.instance):
    """
    Base class for building polyhedron from files. This class builds a new object for each file. 
    """
    def __init__(self, node_type: NODE_TYPE) -> None: 
        """
        __init__( (object)self [, (NODE_TYPE)node_type]) -> None :

            C++ signature :
                void __init__(_object* [,hpp::fcl::NODE_TYPE])
        """
    def load(self, filename_: str, scale: object) -> BVHModelBase: 
        """
        load( (MeshLoader)self, (str)filename [, (object)scale]) -> BVHModelBase :

            C++ signature :
                boost::shared_ptr<hpp::fcl::BVHModelBase> load(hpp::fcl::MeshLoader {lvalue},std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> > [,Eigen::Matrix<double, 3, 1, 0, 3, 1>])
        """
    def loadOctree(self, filename: str) -> CollisionGeometry: 
        """
        loadOctree( (MeshLoader)self, (str)filename) -> CollisionGeometry :
            Create an hpp::fcl::OcTree from a file in binary octomap format. Todoadd OctreePtr_t 

            C++ signature :
                boost::shared_ptr<hpp::fcl::CollisionGeometry> loadOctree(hpp::fcl::MeshLoader {lvalue},std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> >)
        """
    __instance_size__ = 32
    pass

class Capsule(ShapeBase, CollisionGeometry, Boost.Python.instance):
    """
    hpp::fcl::Capsule It is x ∈ ℝ^3, d(x, AB) ≤ radius where d(x, AB) is the distance between the point x and the capsule segment AB, with A = (0,0,-halfLength), B = (0,0,halfLength). 
    """
    def __init__(self, radius_: float, lz_: float) -> None: 
        """
        __init__( (object)self, (float)radius_, (float)lz_) -> None :

            C++ signature :
                void __init__(_object*,double,double)
        """
    @staticmethod
    def clone(arg1: Capsule) -> Capsule: 
        """
        clone( (Capsule)arg1) -> Capsule :
            Clone *this into a new hpp::fcl::Capsule. 

            C++ signature :
                hpp::fcl::Capsule* clone(hpp::fcl::Capsule {lvalue})
        """
    @property
    def halfLength(self) -> None:
        """
        Half Length along z axis. 

        :type: None
        """
    @property
    def radius(self) -> None:
        """
        Radius of capsule. 

        :type: None
        """
    pass

class BVHModelOBB(BVHModelBase, CollisionGeometry, Boost.Python.instance):
    """
    A class describing the bounding hierarchy of a mesh model or a point cloud model (which is viewed as a degraded version of mesh) 


    Templateparam
      - BV one of the bounding volume class in Bounding volumes. 
    """
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :
            Default constructor to build an empty BVH. 

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,hpp::fcl::BVHModel<hpp::fcl::OBB>)
        """
    @typing.overload
    def __init__(self, other: BVHModelOBB) -> None: ...
    @staticmethod
    def clone(arg1: BVHModelOBB) -> BVHModelOBB: 
        """
        clone( (BVHModelOBB)arg1) -> BVHModelOBB :
            Clone *this into a new hpp::fcl::BVHModel. 

            C++ signature :
                hpp::fcl::BVHModel<hpp::fcl::OBB>* clone(hpp::fcl::BVHModel<hpp::fcl::OBB> {lvalue})
        """
    def getNumBVs(self) -> int: 
        """
        getNumBVs( (BVHModelOBB)self) -> int :
            Get the number of bv in the BVH. 

            C++ signature :
                unsigned int getNumBVs(hpp::fcl::BVHModel<hpp::fcl::OBB> {lvalue})
        """
    def makeParentRelative(self) -> None: 
        """
        makeParentRelative( (BVHModelOBB)self) -> None :
            This is a special acceleration: BVH_model default stores the BV's transform in world coordinate. However, we can also store each BV's transform related to its parent BV node. When traversing the BVH, this can save one matrix transformation. 

            C++ signature :
                void makeParentRelative(hpp::fcl::BVHModel<hpp::fcl::OBB> {lvalue})
        """
    def memUsage(self, msg: bool) -> int: 
        """
        memUsage( (BVHModelOBB)self, (bool)msg) -> int :

            C++ signature :
                int memUsage(hpp::fcl::BVHModel<hpp::fcl::OBB> {lvalue},bool)
        """
    pass

class CollisionObject(Boost.Python.instance):
    @staticmethod
    @typing.overload
    def __init__(arg1: object, arg2: CollisionGeometry) -> None: 
        """
        __init__( (object)arg1, (CollisionGeometry)arg2) -> None :

            C++ signature :
                void __init__(_object*,boost::shared_ptr<hpp::fcl::CollisionGeometry>)

            C++ signature :
                void __init__(_object*,boost::shared_ptr<hpp::fcl::CollisionGeometry>,hpp::fcl::Transform3f)

            C++ signature :
                void __init__(_object*,boost::shared_ptr<hpp::fcl::CollisionGeometry>,Eigen::Matrix<double, 3, 3, 0, 3, 3>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @staticmethod
    @typing.overload
    def __init__(arg1: object, arg2: CollisionGeometry, arg3: Transform3f) -> None: ...
    @staticmethod
    @typing.overload
    def __init__(arg1: object, arg2: CollisionGeometry, arg3: object, arg4: object) -> None: ...
    @staticmethod
    def collisionGeometry(arg1: CollisionObject) -> CollisionGeometry: 
        """
        collisionGeometry( (CollisionObject)arg1) -> CollisionGeometry :

            C++ signature :
                boost::shared_ptr<hpp::fcl::CollisionGeometry> collisionGeometry(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def computeAABB(arg1: CollisionObject) -> None: 
        """
        computeAABB( (CollisionObject)arg1) -> None :

            C++ signature :
                void computeAABB(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def getAABB(arg1: CollisionObject) -> AABB: 
        """
        getAABB( (CollisionObject)arg1) -> AABB :

            C++ signature :
                hpp::fcl::AABB getAABB(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def getNodeType(arg1: CollisionObject) -> NODE_TYPE: 
        """
        getNodeType( (CollisionObject)arg1) -> NODE_TYPE :

            C++ signature :
                hpp::fcl::NODE_TYPE getNodeType(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def getObjectType(arg1: CollisionObject) -> OBJECT_TYPE: 
        """
        getObjectType( (CollisionObject)arg1) -> OBJECT_TYPE :

            C++ signature :
                hpp::fcl::OBJECT_TYPE getObjectType(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def getRotation(arg1: CollisionObject) -> object: 
        """
        getRotation( (CollisionObject)arg1) -> object :

            C++ signature :
                Eigen::Matrix<double, 3, 3, 0, 3, 3> getRotation(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def getTransform(arg1: CollisionObject) -> Transform3f: 
        """
        getTransform( (CollisionObject)arg1) -> Transform3f :

            C++ signature :
                hpp::fcl::Transform3f getTransform(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def getTranslation(arg1: CollisionObject) -> object: 
        """
        getTranslation( (CollisionObject)arg1) -> object :

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> getTranslation(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def isIdentityTransform(arg1: CollisionObject) -> bool: 
        """
        isIdentityTransform( (CollisionObject)arg1) -> bool :

            C++ signature :
                bool isIdentityTransform(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def setIdentityTransform(arg1: CollisionObject) -> None: 
        """
        setIdentityTransform( (CollisionObject)arg1) -> None :

            C++ signature :
                void setIdentityTransform(hpp::fcl::CollisionObject {lvalue})
        """
    @staticmethod
    def setRotation(arg1: CollisionObject, arg2: object) -> None: 
        """
        setRotation( (CollisionObject)arg1, (object)arg2) -> None :

            C++ signature :
                void setRotation(hpp::fcl::CollisionObject {lvalue},Eigen::Matrix<double, 3, 3, 0, 3, 3>)
        """
    @staticmethod
    def setTransform(arg1: CollisionObject, arg2: Transform3f) -> None: 
        """
        setTransform( (CollisionObject)arg1, (Transform3f)arg2) -> None :

            C++ signature :
                void setTransform(hpp::fcl::CollisionObject {lvalue},hpp::fcl::Transform3f)
        """
    @staticmethod
    def setTranslation(arg1: CollisionObject, arg2: object) -> None: 
        """
        setTranslation( (CollisionObject)arg1, (object)arg2) -> None :

            C++ signature :
                void setTranslation(hpp::fcl::CollisionObject {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    pass

class QueryRequest(Boost.Python.instance):
    """
    base class for all query requests 
    """
    def updateGuess(self, result: QueryResult) -> None: 
        """
        updateGuess( (QueryRequest)self, (QueryResult)result) -> None :

            C++ signature :
                void updateGuess(hpp::fcl::QueryRequest {lvalue},hpp::fcl::QueryResult)
        """
    @property
    def cached_gjk_guess(self) -> None:
        """
        the gjk intial guess set by user 

        :type: None
        """
    @property
    def cached_support_func_guess(self) -> None:
        """
        the support function intial guess set by user 

        :type: None
        """
    @property
    def enable_cached_gjk_guess(self) -> None:
        """
        whether enable gjk intial guess 

        :type: None
        """
    @property
    def enable_timings(self) -> None:
        """
        enable timings when performing collision/distance request 

        :type: None
        """
    pass

class QueryResult(Boost.Python.instance):
    """
    base class for all query results 
    """
    @property
    def cached_gjk_guess(self) -> None:
        """
        stores the last GJK ray when relevant. 

        :type: None
        """
    @property
    def cached_support_func_guess(self) -> None:
        """
        stores the last support function vertex index, when relevant. 

        :type: None
        """
    @property
    def timings(self) -> None:
        """
        timings for the given request 

        :type: None
        """
    pass

class ComputeCollision(Boost.Python.instance):
    @staticmethod
    def __call__(arg1: ComputeCollision, arg2: Transform3f, arg3: Transform3f, arg4: CollisionRequest, arg5: CollisionResult) -> int: 
        """
        __call__( (ComputeCollision)arg1, (Transform3f)arg2, (Transform3f)arg3, (CollisionRequest)arg4, (CollisionResult)arg5) -> int :

            C++ signature :
                unsigned long __call__(hpp::fcl::ComputeCollision {lvalue},hpp::fcl::Transform3f,hpp::fcl::Transform3f,hpp::fcl::CollisionRequest {lvalue},hpp::fcl::CollisionResult {lvalue})
        """
    @staticmethod
    def __init__(arg1: object, arg2: CollisionGeometry, arg3: CollisionGeometry) -> None: 
        """
        __init__( (object)arg1, (CollisionGeometry)arg2, (CollisionGeometry)arg3) -> None :

            C++ signature :
                void __init__(_object*,hpp::fcl::CollisionGeometry const*,hpp::fcl::CollisionGeometry const*)
        """
    pass

class ComputeDistance(Boost.Python.instance):
    @staticmethod
    def __call__(arg1: ComputeDistance, arg2: Transform3f, arg3: Transform3f, arg4: DistanceRequest, arg5: DistanceResult) -> float: 
        """
        __call__( (ComputeDistance)arg1, (Transform3f)arg2, (Transform3f)arg3, (DistanceRequest)arg4, (DistanceResult)arg5) -> float :

            C++ signature :
                double __call__(hpp::fcl::ComputeDistance {lvalue},hpp::fcl::Transform3f,hpp::fcl::Transform3f,hpp::fcl::DistanceRequest {lvalue},hpp::fcl::DistanceResult {lvalue})
        """
    @staticmethod
    def __init__(arg1: object, arg2: CollisionGeometry, arg3: CollisionGeometry) -> None: 
        """
        __init__( (object)arg1, (CollisionGeometry)arg2, (CollisionGeometry)arg3) -> None :

            C++ signature :
                void __init__(_object*,hpp::fcl::CollisionGeometry const*,hpp::fcl::CollisionGeometry const*)
        """
    pass

class Cone(ShapeBase, CollisionGeometry, Boost.Python.instance):
    """
    hpp::fcl::Cone The base of the cone is at z = - halfLength and the top is at z = halfLength. 
    """
    def __init__(self, radius_: float, lz_: float) -> None: 
        """
        __init__( (object)self, (float)radius_, (float)lz_) -> None :

            C++ signature :
                void __init__(_object*,double,double)
        """
    @staticmethod
    def clone(arg1: Cone) -> Cone: 
        """
        clone( (Cone)arg1) -> Cone :
            Clone *this into a new hpp::fcl::Cone. 

            C++ signature :
                hpp::fcl::Cone* clone(hpp::fcl::Cone {lvalue})
        """
    @property
    def halfLength(self) -> None:
        """
        Half Length along z axis. 

        :type: None
        """
    @property
    def radius(self) -> None:
        """
        Radius of the cone. 

        :type: None
        """
    pass

class Contact(Boost.Python.instance):
    """
    hpp::fcl::Contact information returned by collision. 
    """
    @staticmethod
    def __eq__(arg1: Contact, arg2: Contact) -> object: 
        """
        __eq__( (Contact)arg1, (Contact)arg2) -> object :

            C++ signature :
                _object* __eq__(hpp::fcl::Contact {lvalue},hpp::fcl::Contact)
        """
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :
            Default constructor

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,hpp::fcl::CollisionGeometry const*,hpp::fcl::CollisionGeometry const*,int,int)

            C++ signature :
                void __init__(_object*,hpp::fcl::CollisionGeometry const*,hpp::fcl::CollisionGeometry const*,int,int,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>,double)
        """
    @typing.overload
    def __init__(self, o1_: CollisionGeometry, o2_: CollisionGeometry, b1_: int, b2_: int) -> None: ...
    @typing.overload
    def __init__(self, o1_: CollisionGeometry, o2_: CollisionGeometry, b1_: int, b2_: int, pos_: object, normal_: object, depth_: float) -> None: ...
    @staticmethod
    def __ne__(arg1: Contact, arg2: Contact) -> object: 
        """
        __ne__( (Contact)arg1, (Contact)arg2) -> object :

            C++ signature :
                _object* __ne__(hpp::fcl::Contact {lvalue},hpp::fcl::Contact)
        """
    @property
    def b1(self) -> None:
        """
        contact primitive in object 1 if object 1 is mesh or point cloud, it is the triangle or point id if object 1 is geometry shape, it is NONE (-1), if object 1 is octree, it is the id of the cell 

        :type: None
        """
    @property
    def b2(self) -> None:
        """
        contact primitive in object 2 if object 2 is mesh or point cloud, it is the triangle or point id if object 2 is geometry shape, it is NONE (-1), if object 2 is octree, it is the id of the cell 

        :type: None
        """
    @property
    def normal(self) -> None:
        """
        contact normal, pointing from o1 to o2 

        :type: None
        """
    @property
    def o1(self) -> None:
        """
        collision object 1 

        :type: None
        """
    @property
    def o2(self) -> None:
        """
        collision object 2 

        :type: None
        """
    @property
    def penetration_depth(self) -> None:
        """
        penetration depth 

        :type: None
        """
    @property
    def pos(self) -> None:
        """
        contact position, in world space 

        :type: None
        """
    __instance_size__ = 96
    pass

class ConvexBase(ShapeBase, CollisionGeometry, Boost.Python.instance):
    """
    Base for convex polytope. 

    Note: Inherited classes are responsible for filling ConvexBase::neighbors; 
    """
    @staticmethod
    def clone(arg1: ConvexBase) -> ConvexBase: 
        """
        clone( (ConvexBase)arg1) -> ConvexBase :
            Clone (deep copy). 

            C++ signature :
                hpp::fcl::ConvexBase* clone(hpp::fcl::ConvexBase {lvalue})
        """
    @staticmethod
    def convexHull(arg1: StdVec_Vec3f, arg2: bool, arg3: str) -> ConvexBase: 
        """
        convexHull( (StdVec_Vec3f)arg1, (bool)arg2, (str)arg3) -> ConvexBase :
            Build a convex hull based on Qhull library and store the vertices and optionally the triangles. 
            
            
            Param
              - points, num_points the points whose convex hull should be computed. 
              - keepTriangles if true, returns a Convex<Triangle> object which contains the triangle of the shape. 
              - qhullCommand the command sent to qhull.
            - if keepTriangles is true, this parameter should include "Qt". If NULL, "Qt" is passed to Qhull.
            - if keepTriangles is false, an empty string is passed to Qhull. 
            
            
            
            Note: hpp-fcl must have been compiled with option HPP_FCL_HAS_QHULL set to ON. 

            C++ signature :
                hpp::fcl::ConvexBase* convexHull(std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > >,bool,char const*)
        """
    @staticmethod
    def neighbors(arg1: ConvexBase, arg2: int) -> list: 
        """
        neighbors( (ConvexBase)arg1, (int)arg2) -> list :

            C++ signature :
                boost::python::list neighbors(hpp::fcl::ConvexBase,unsigned int)
        """
    def point(self, index: int) -> object: 
        """
        point( (ConvexBase)self, (int)index) -> object :
            Retrieve the point given by its index.

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> {lvalue} point(hpp::fcl::ConvexBase,unsigned int)
        """
    @typing.overload
    def points(self) -> object: 
        """
        points( (ConvexBase)self, (int)index) -> object :
            Retrieve the point given by its index.

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> {lvalue} points(hpp::fcl::ConvexBase,unsigned int)

            C++ signature :
                Eigen::Ref<Eigen::Matrix<double, -1, 3, 1, -1, 3>, 0, Eigen::OuterStride<-1> > points(hpp::fcl::ConvexBase)
        """
    @typing.overload
    def points(self, index: int) -> object: ...
    @property
    def center(self) -> None:
        """
        center of the convex polytope, this is used for collision: center is guaranteed in the internal of the polytope (as it is convex) 

        :type: None
        """
    @property
    def num_points(self) -> None:
        """
        :type: None
        """
    pass

class Convex(ConvexBase, ShapeBase, CollisionGeometry, Boost.Python.instance):
    @staticmethod
    def __init__(arg1: object, arg2: StdVec_Vec3f, arg3: StdVec_Triangle) -> object: 
        """
        __init__( (object)arg1, (StdVec_Vec3f)arg2, (StdVec_Triangle)arg3) -> object :

            C++ signature :
                void* __init__(boost::python::api::object,std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > >,std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> >)
        """
    @staticmethod
    def polygons(arg1: Convex, arg2: int) -> Triangle: 
        """
        polygons( (Convex)arg1, (int)arg2) -> Triangle :

            C++ signature :
                hpp::fcl::Triangle polygons(hpp::fcl::Convex<hpp::fcl::Triangle>,unsigned int)
        """
    @property
    def num_polygons(self) -> None:
        """
        :type: None
        """
    pass

class Cylinder(ShapeBase, CollisionGeometry, Boost.Python.instance):
    """
    hpp::fcl::Cylinder along Z axis. The cylinder is defined at its centroid. 
    """
    def __init__(self, radius_: float, lz_: float) -> None: 
        """
        __init__( (object)self, (float)radius_, (float)lz_) -> None :

            C++ signature :
                void __init__(_object*,double,double)
        """
    @staticmethod
    def clone(arg1: Cylinder) -> Cylinder: 
        """
        clone( (Cylinder)arg1) -> Cylinder :
            Clone *this into a new hpp::fcl::Cylinder. 

            C++ signature :
                hpp::fcl::Cylinder* clone(hpp::fcl::Cylinder {lvalue})
        """
    @property
    def halfLength(self) -> None:
        """
        Half Length along z axis. 

        :type: None
        """
    @property
    def radius(self) -> None:
        """
        Radius of the cylinder. 

        :type: None
        """
    pass

class DistanceRequest(QueryRequest, Boost.Python.instance):
    """
    request to the distance computation 
    """
    def __init__(self, enable_nearest_points_: bool, rel_err_: float, abs_err: float) -> None: 
        """
        __init__( (object)self [, (bool)enable_nearest_points [, (float)rel_err [, (float)abs_err]]]) -> None :
            Constructor

            C++ signature :
                void __init__(_object* [,bool [,double [,double]]])
        """
    @property
    def abs_err(self) -> None:
        """
        :type: None
        """
    @property
    def enable_nearest_points(self) -> None:
        """
        whether to return the nearest points 

        :type: None
        """
    @property
    def rel_err(self) -> None:
        """
        error threshold for approximate distance 

        :type: None
        """
    __instance_size__ = 80
    pass

class DistanceResult(QueryResult, Boost.Python.instance):
    """
    distance result 
    """
    @staticmethod
    def __init__(arg1: object) -> None: 
        """
        __init__( (object)arg1) -> None :

            C++ signature :
                void __init__(_object*)
        """
    @staticmethod
    def clear(arg1: DistanceResult) -> None: 
        """
        clear( (DistanceResult)arg1) -> None :
            clear the result 

            C++ signature :
                void clear(hpp::fcl::DistanceResult {lvalue})
        """
    @staticmethod
    def getNearestPoint1(arg1: DistanceResult) -> object: 
        """
        getNearestPoint1( (DistanceResult)arg1) -> object :
            nearest points 

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> getNearestPoint1(hpp::fcl::DistanceResult)
        """
    @staticmethod
    def getNearestPoint2(arg1: DistanceResult) -> object: 
        """
        getNearestPoint2( (DistanceResult)arg1) -> object :
            nearest points 

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> getNearestPoint2(hpp::fcl::DistanceResult)
        """
    @property
    def b1(self) -> None:
        """
        information about the nearest point in object 1 if object 1 is mesh or point cloud, it is the triangle or point id if object 1 is geometry shape, it is NONE (-1), if object 1 is octree, it is the id of the cell 

        :type: None
        """
    @property
    def b2(self) -> None:
        """
        information about the nearest point in object 2 if object 2 is mesh or point cloud, it is the triangle or point id if object 2 is geometry shape, it is NONE (-1), if object 2 is octree, it is the id of the cell 

        :type: None
        """
    @property
    def min_distance(self) -> None:
        """
        minimum distance between two objects. if two objects are in collision, min_distance <= 0. 

        :type: None
        """
    @property
    def normal(self) -> None:
        """
        In case both objects are in collision, store the normal. 

        :type: None
        """
    @property
    def o1(self) -> None:
        """
        collision object 1 

        :type: None
        """
    @property
    def o2(self) -> None:
        """
        collision object 2 

        :type: None
        """
    pass

class Exception(Boost.Python.instance):
    @staticmethod
    def __init__(arg1: object, arg2: str) -> None: 
        """
        __init__( (object)arg1, (str)arg2) -> None :

            C++ signature :
                void __init__(_object*,std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> >)
        """
    @property
    def message(self) -> None:
        """
        :type: None
        """
    __instance_size__ = 56
    pass

class GJK(Boost.Python.instance):
    """
    class for hpp::fcl::details::GJK algorithm 

    Note: The computations are performed in the frame of the first shape. 
    """
    def __init__(self, max_iterations_: int, tolerance_: float) -> None: 
        """
        __init__( (object)self, (int)max_iterations_, (float)tolerance_) -> None :
            Param
              - max_iterations_ number of iteration before hpp::fcl::details::GJK returns failure. 
              - tolerance_ precision of the algorithm.
            
            The tolerance argument is useful for continuous shapes and for polyhedron with some vertices closer than this threshold.
            Suggested values are 100 iterations and a tolerance of 1e-6. 

            C++ signature :
                void __init__(_object*,unsigned int,double)
        """
    @staticmethod
    def evaluate(arg1: GJK, arg2: MinkowskiDiff, arg3: object, arg4: object) -> GJKStatus: 
        """
        evaluate( (GJK)arg1, (MinkowskiDiff)arg2, (object)arg3, (object)arg4) -> GJKStatus :
            hpp::fcl::details::GJK algorithm, given the initial value guess. 

            C++ signature :
                hpp::fcl::details::GJK::Status evaluate(hpp::fcl::details::GJK {lvalue},hpp::fcl::details::MinkowskiDiff,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<int, 2, 1, 0, 2, 1>)
        """
    @staticmethod
    def getClosestPoints(arg1: GJK, arg2: MinkowskiDiff, arg3: object, arg4: object) -> bool: 
        """
        getClosestPoints( (GJK)arg1, (MinkowskiDiff)arg2, (object)arg3, (object)arg4) -> bool :
            Get the closest points on each object. Return: true on success 

            C++ signature :
                bool getClosestPoints(hpp::fcl::details::GJK {lvalue},hpp::fcl::details::MinkowskiDiff,Eigen::Matrix<double, 3, 1, 0, 3, 1> {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1> {lvalue})
        """
    @staticmethod
    def getGuessFromSimplex(arg1: GJK) -> object: 
        """
        getGuessFromSimplex( (GJK)arg1) -> object :
            get the guess from current simplex 

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> getGuessFromSimplex(hpp::fcl::details::GJK {lvalue})
        """
    @staticmethod
    def hasClosestPoints(arg1: GJK) -> bool: 
        """
        hasClosestPoints( (GJK)arg1) -> bool :
            Tells whether the closest points are available. 

            C++ signature :
                bool hasClosestPoints(hpp::fcl::details::GJK {lvalue})
        """
    @staticmethod
    def hasPenetrationInformation(arg1: GJK, arg2: MinkowskiDiff) -> bool: 
        """
        hasPenetrationInformation( (GJK)arg1, (MinkowskiDiff)arg2) -> bool :
            Tells whether the penetration information.
            In such case, most indepth points and penetration depth can be retrieved from hpp::fcl::details::GJK. Calling hpp::fcl::details::EPA has an undefined behaviour. 

            C++ signature :
                bool hasPenetrationInformation(hpp::fcl::details::GJK {lvalue},hpp::fcl::details::MinkowskiDiff)
        """
    @staticmethod
    def setDistanceEarlyBreak(arg1: GJK, arg2: float) -> None: 
        """
        setDistanceEarlyBreak( (GJK)arg1, (float)arg2) -> None :
            Distance threshold for early break. hpp::fcl::details::GJK stops when it proved the distance is more than this threshold. 
            
            Note: The closest points will be erroneous in this case. If you want the closest points, set this to infinity (the default). 

            C++ signature :
                void setDistanceEarlyBreak(hpp::fcl::details::GJK {lvalue},double)
        """
    @property
    def distance(self) -> None:
        """
        The distance computed by hpp::fcl::details::GJK. The possible values are
        - d = - R - 1 when a collision is detected and hpp::fcl::details::GJK cannot compute penetration informations.
        - - R ≤ d ≤ 0 when a collision is detected and hpp::fcl::details::GJK can compute penetration informations.
        - 0 < d ≤ d_ub when there is no collision and hpp::fcl::details::GJK can compute the closest points.
        - d_ub < d when there is no collision and hpp::fcl::details::GJK cannot compute the closest points.


        where d is the GJK::distance, R is the sum of the shape MinkowskiDiff::inflation and d_ub is the GJK::distance_upper_bound. 

        :type: None
        """
    @property
    def ray(self) -> None:
        """
        :type: None
        """
    @property
    def support_hint(self) -> None:
        """
        :type: None
        """
    pass

class Halfspace(ShapeBase, CollisionGeometry, Boost.Python.instance):
    """
    Half Space: this is equivalent to the hpp::fcl::Plane in ODE. The separation plane is defined as n * x = d; Points in the negative side of the separation plane (i.e. {x | n * x < d}) are inside the half space and points in the positive side of the separation plane (i.e. {x | n * x > d}) are outside the half space. 
    """
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self, (object)n_, (float)d_) -> None :
            Construct a half space with normal direction and offset. 

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 1, 0, 3, 1>,double)

            C++ signature :
                void __init__(_object*,double,double,double,double)

            C++ signature :
                void __init__(_object*)
        """
    @typing.overload
    def __init__(self, a: float, b: float, c: float, d_: float) -> None: ...
    @typing.overload
    def __init__(self, n_: object, d_: float) -> None: ...
    @staticmethod
    def clone(arg1: Halfspace) -> Halfspace: 
        """
        clone( (Halfspace)arg1) -> Halfspace :
            Clone *this into a new hpp::fcl::Halfspace. 

            C++ signature :
                hpp::fcl::Halfspace* clone(hpp::fcl::Halfspace {lvalue})
        """
    @property
    def d(self) -> None:
        """
        hpp::fcl::Plane offset. 

        :type: None
        """
    @property
    def n(self) -> None:
        """
        hpp::fcl::Plane normal. 

        :type: None
        """
    pass

class HeightFieldAABB(CollisionGeometry, Boost.Python.instance):
    """
    Data structure depicting a height field given by the base grid dimensions and the elevation along the grid. 


    Templateparam
      - BV one of the bounding volume class in Bounding volumes.

    An height field is defined by its base dimensions along the X and Y axes and a set ofpoints defined by their altitude, regularly dispatched on the grid. The height field is centered at the origin and the corners of the geometry correspond to the following coordinates [± x_dim/2; ± y_dim/2]. 
    """
    @staticmethod
    @typing.overload
    def __init__(arg1: object, arg2: float, arg3: float, arg4_: object, arg5: float) -> None: 
        """
        __init__( (object)self) -> None :
            Constructing an empty hpp::fcl::HeightField. 

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,hpp::fcl::HeightField<hpp::fcl::AABB>)

            C++ signature :
                void __init__(_object*,double,double,Eigen::Matrix<double, -1, -1, 0, -1, -1> [,double])
        """
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, other: HeightFieldAABB) -> None: ...
    @staticmethod
    def clone(arg1: HeightFieldAABB) -> HeightFieldAABB: 
        """
        clone( (HeightFieldAABB)arg1) -> HeightFieldAABB :
            Clone *this into a new hpp::fcl::CollisionGeometry. 

            C++ signature :
                hpp::fcl::HeightField<hpp::fcl::AABB>* clone(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue})
        """
    @staticmethod
    def getBV(arg1: HeightFieldAABB, arg2: int) -> object: 
        """
        getBV( (HeightFieldAABB)arg1, (int)arg2) -> object :
            Access the bv giving the its index. 

            C++ signature :
                hpp::fcl::HFNode<hpp::fcl::AABB> {lvalue} getBV(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue},unsigned int)
        """
    @staticmethod
    def getHeights(arg1: HeightFieldAABB) -> object: 
        """
        getHeights( (HeightFieldAABB)arg1) -> object :
            Returns a const reference of the heights. 

            C++ signature :
                Eigen::Matrix<double, -1, -1, 0, -1, -1> getHeights(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue})
        """
    def getMaxHeight(self) -> float: 
        """
        getMaxHeight( (HeightFieldAABB)self) -> float :
            Returns the maximal height value of the Height Field. 

            C++ signature :
                double getMaxHeight(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue})
        """
    def getMinHeight(self) -> float: 
        """
        getMinHeight( (HeightFieldAABB)self) -> float :
            Returns the minimal height value of the Height Field. 

            C++ signature :
                double getMinHeight(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue})
        """
    def getNodeType(self) -> NODE_TYPE: 
        """
        getNodeType( (HeightFieldAABB)self) -> NODE_TYPE :
            Get the BV type: default is unknown. 

            C++ signature :
                hpp::fcl::NODE_TYPE getNodeType(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue})
        """
    def getXDim(self) -> float: 
        """
        getXDim( (HeightFieldAABB)self) -> float :
            Returns the dimension of the Height Field along the X direction. 

            C++ signature :
                double getXDim(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue})
        """
    @staticmethod
    def getXGrid(arg1: HeightFieldAABB) -> object: 
        """
        getXGrid( (HeightFieldAABB)arg1) -> object :
            Returns a const reference of the grid along the X direction. 

            C++ signature :
                Eigen::Matrix<double, -1, 1, 0, -1, 1> getXGrid(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue})
        """
    def getYDim(self) -> float: 
        """
        getYDim( (HeightFieldAABB)self) -> float :
            Returns the dimension of the Height Field along the Y direction. 

            C++ signature :
                double getYDim(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue})
        """
    @staticmethod
    def getYGrid(arg1: HeightFieldAABB) -> object: 
        """
        getYGrid( (HeightFieldAABB)arg1) -> object :
            Returns a const reference of the grid along the Y direction. 

            C++ signature :
                Eigen::Matrix<double, -1, 1, 0, -1, 1> getYGrid(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue})
        """
    def updateHeights(self, new_heights: object) -> None: 
        """
        updateHeights( (HeightFieldAABB)self, (object)new_heights) -> None :
            Update Height Field height. 

            C++ signature :
                void updateHeights(hpp::fcl::HeightField<hpp::fcl::AABB> {lvalue},Eigen::Matrix<double, -1, -1, 0, -1, -1>)
        """
    pass

class HeightFieldOBBRSS(CollisionGeometry, Boost.Python.instance):
    """
    Data structure depicting a height field given by the base grid dimensions and the elevation along the grid. 


    Templateparam
      - BV one of the bounding volume class in Bounding volumes.

    An height field is defined by its base dimensions along the X and Y axes and a set ofpoints defined by their altitude, regularly dispatched on the grid. The height field is centered at the origin and the corners of the geometry correspond to the following coordinates [± x_dim/2; ± y_dim/2]. 
    """
    @staticmethod
    @typing.overload
    def __init__(arg1: object, arg2: float, arg3: float, arg4_: object, arg5: float) -> None: 
        """
        __init__( (object)self) -> None :
            Constructing an empty hpp::fcl::HeightField. 

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,hpp::fcl::HeightField<hpp::fcl::OBBRSS>)

            C++ signature :
                void __init__(_object*,double,double,Eigen::Matrix<double, -1, -1, 0, -1, -1> [,double])
        """
    @typing.overload
    def __init__(self) -> None: ...
    @typing.overload
    def __init__(self, other: HeightFieldOBBRSS) -> None: ...
    @staticmethod
    def clone(arg1: HeightFieldOBBRSS) -> HeightFieldOBBRSS: 
        """
        clone( (HeightFieldOBBRSS)arg1) -> HeightFieldOBBRSS :
            Clone *this into a new hpp::fcl::CollisionGeometry. 

            C++ signature :
                hpp::fcl::HeightField<hpp::fcl::OBBRSS>* clone(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue})
        """
    @staticmethod
    def getBV(arg1: HeightFieldOBBRSS, arg2: int) -> object: 
        """
        getBV( (HeightFieldOBBRSS)arg1, (int)arg2) -> object :
            Access the bv giving the its index. 

            C++ signature :
                hpp::fcl::HFNode<hpp::fcl::OBBRSS> {lvalue} getBV(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue},unsigned int)
        """
    @staticmethod
    def getHeights(arg1: HeightFieldOBBRSS) -> object: 
        """
        getHeights( (HeightFieldOBBRSS)arg1) -> object :
            Returns a const reference of the heights. 

            C++ signature :
                Eigen::Matrix<double, -1, -1, 0, -1, -1> getHeights(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue})
        """
    def getMaxHeight(self) -> float: 
        """
        getMaxHeight( (HeightFieldOBBRSS)self) -> float :
            Returns the maximal height value of the Height Field. 

            C++ signature :
                double getMaxHeight(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue})
        """
    def getMinHeight(self) -> float: 
        """
        getMinHeight( (HeightFieldOBBRSS)self) -> float :
            Returns the minimal height value of the Height Field. 

            C++ signature :
                double getMinHeight(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue})
        """
    def getNodeType(self) -> NODE_TYPE: 
        """
        getNodeType( (HeightFieldOBBRSS)self) -> NODE_TYPE :
            Get the BV type: default is unknown. 

            C++ signature :
                hpp::fcl::NODE_TYPE getNodeType(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue})
        """
    def getXDim(self) -> float: 
        """
        getXDim( (HeightFieldOBBRSS)self) -> float :
            Returns the dimension of the Height Field along the X direction. 

            C++ signature :
                double getXDim(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue})
        """
    @staticmethod
    def getXGrid(arg1: HeightFieldOBBRSS) -> object: 
        """
        getXGrid( (HeightFieldOBBRSS)arg1) -> object :
            Returns a const reference of the grid along the X direction. 

            C++ signature :
                Eigen::Matrix<double, -1, 1, 0, -1, 1> getXGrid(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue})
        """
    def getYDim(self) -> float: 
        """
        getYDim( (HeightFieldOBBRSS)self) -> float :
            Returns the dimension of the Height Field along the Y direction. 

            C++ signature :
                double getYDim(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue})
        """
    @staticmethod
    def getYGrid(arg1: HeightFieldOBBRSS) -> object: 
        """
        getYGrid( (HeightFieldOBBRSS)arg1) -> object :
            Returns a const reference of the grid along the Y direction. 

            C++ signature :
                Eigen::Matrix<double, -1, 1, 0, -1, 1> getYGrid(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue})
        """
    def updateHeights(self, new_heights: object) -> None: 
        """
        updateHeights( (HeightFieldOBBRSS)self, (object)new_heights) -> None :
            Update Height Field height. 

            C++ signature :
                void updateHeights(hpp::fcl::HeightField<hpp::fcl::OBBRSS> {lvalue},Eigen::Matrix<double, -1, -1, 0, -1, -1>)
        """
    pass

class CachedMeshLoader(MeshLoader, Boost.Python.instance):
    """
    Base class for building polyhedron from files. This class builds a new object for each file. 
    """
    def __init__(self, node_type: NODE_TYPE) -> None: 
        """
        __init__( (object)self [, (NODE_TYPE)node_type]) -> None :

            C++ signature :
                void __init__(_object* [,hpp::fcl::NODE_TYPE])
        """
    __instance_size__ = 32
    pass

class MinkowskiDiff(Boost.Python.instance):
    """
    Minkowski difference class of two shapes. 

    Note: The Minkowski difference is expressed in the frame of the first shape. 
    """
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :

            C++ signature :
                void __init__(_object*)
        """
    @staticmethod
    @typing.overload
    def set(arg1: MinkowskiDiff, arg2: ShapeBase, arg3: ShapeBase) -> None: 
        """
        set( (MinkowskiDiff)arg1, (ShapeBase)arg2, (ShapeBase)arg3) -> None :
            Set the two shapes, assuming the relative transformation between them is identity. 

            C++ signature :
                void set(hpp::fcl::details::MinkowskiDiff {lvalue},hpp::fcl::ShapeBase const*,hpp::fcl::ShapeBase const*)

            C++ signature :
                void set(hpp::fcl::details::MinkowskiDiff {lvalue},hpp::fcl::ShapeBase const*,hpp::fcl::ShapeBase const*,hpp::fcl::Transform3f,hpp::fcl::Transform3f)
        """
    @staticmethod
    @typing.overload
    def set(arg1: MinkowskiDiff, arg2: ShapeBase, arg3: ShapeBase, arg4: Transform3f, arg5: Transform3f) -> None: ...
    @staticmethod
    def support(arg1: MinkowskiDiff, arg2: object, arg3: bool, arg4: object, arg5: object, arg6: object) -> None: 
        """
        support( (MinkowskiDiff)arg1, (object)arg2, (bool)arg3, (object)arg4, (object)arg5, (object)arg6) -> None :
            support function for the pair of shapes 

            C++ signature :
                void support(hpp::fcl::details::MinkowskiDiff {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>,bool,Eigen::Matrix<double, 3, 1, 0, 3, 1> {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1> {lvalue},Eigen::Matrix<int, 2, 1, 0, 2, 1> {lvalue})
        """
    @staticmethod
    def support0(arg1: MinkowskiDiff, arg2: object, arg3: bool, arg4: int) -> object: 
        """
        support0( (MinkowskiDiff)arg1, (object)arg2, (bool)arg3, (int)arg4) -> object :
            support function for shape0 

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> support0(hpp::fcl::details::MinkowskiDiff {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>,bool,int {lvalue})
        """
    @staticmethod
    def support1(arg1: MinkowskiDiff, arg2: object, arg3: bool, arg4: int) -> object: 
        """
        support1( (MinkowskiDiff)arg1, (object)arg2, (bool)arg3, (int)arg4) -> object :
            support function for shape1 

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> support1(hpp::fcl::details::MinkowskiDiff {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>,bool,int {lvalue})
        """
    @property
    def inflation(self) -> None:
        """
        The radius of the sphere swepted volume. The 2 values correspond to the inflation of shape 0 and shape 1. 

        :type: None
        """
    pass

class OcTree(CollisionGeometry, Boost.Python.instance):
    @staticmethod
    def __init__(arg1: object, arg2: float) -> None: 
        """
        __init__( (object)arg1, (float)arg2) -> None :

            C++ signature :
                void __init__(_object*,double)
        """
    @staticmethod
    def getDefaultOccupancy(arg1: OcTree) -> float: 
        """
        getDefaultOccupancy( (OcTree)arg1) -> float :

            C++ signature :
                double getDefaultOccupancy(hpp::fcl::OcTree {lvalue})
        """
    @staticmethod
    def getFreeThres(arg1: OcTree) -> float: 
        """
        getFreeThres( (OcTree)arg1) -> float :

            C++ signature :
                double getFreeThres(hpp::fcl::OcTree {lvalue})
        """
    @staticmethod
    def getOccupancyThres(arg1: OcTree) -> float: 
        """
        getOccupancyThres( (OcTree)arg1) -> float :

            C++ signature :
                double getOccupancyThres(hpp::fcl::OcTree {lvalue})
        """
    @staticmethod
    def getRootBV(arg1: OcTree) -> AABB: 
        """
        getRootBV( (OcTree)arg1) -> AABB :

            C++ signature :
                hpp::fcl::AABB getRootBV(hpp::fcl::OcTree {lvalue})
        """
    @staticmethod
    def getTreeDepth(arg1: OcTree) -> int: 
        """
        getTreeDepth( (OcTree)arg1) -> int :

            C++ signature :
                unsigned int getTreeDepth(hpp::fcl::OcTree {lvalue})
        """
    @staticmethod
    def setCellDefaultOccupancy(arg1: OcTree, arg2: float) -> None: 
        """
        setCellDefaultOccupancy( (OcTree)arg1, (float)arg2) -> None :

            C++ signature :
                void setCellDefaultOccupancy(hpp::fcl::OcTree {lvalue},double)
        """
    @staticmethod
    def setFreeThres(arg1: OcTree, arg2: float) -> None: 
        """
        setFreeThres( (OcTree)arg1, (float)arg2) -> None :

            C++ signature :
                void setFreeThres(hpp::fcl::OcTree {lvalue},double)
        """
    @staticmethod
    def setOccupancyThres(arg1: OcTree, arg2: float) -> None: 
        """
        setOccupancyThres( (OcTree)arg1, (float)arg2) -> None :

            C++ signature :
                void setOccupancyThres(hpp::fcl::OcTree {lvalue},double)
        """
    pass

class Plane(ShapeBase, CollisionGeometry, Boost.Python.instance):
    """
    Infinite plane. 
    """
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self, (object)n_, (float)d_) -> None :
            Construct a plane with normal direction and offset. 

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 1, 0, 3, 1>,double)

            C++ signature :
                void __init__(_object*,double,double,double,double)

            C++ signature :
                void __init__(_object*)
        """
    @typing.overload
    def __init__(self, a: float, b: float, c: float, d_: float) -> None: ...
    @typing.overload
    def __init__(self, n_: object, d_: float) -> None: ...
    @staticmethod
    def clone(arg1: Plane) -> Plane: 
        """
        clone( (Plane)arg1) -> Plane :
            Clone *this into a new hpp::fcl::Plane. 

            C++ signature :
                hpp::fcl::Plane* clone(hpp::fcl::Plane {lvalue})
        """
    @property
    def d(self) -> None:
        """
        hpp::fcl::Plane offset. 

        :type: None
        """
    @property
    def n(self) -> None:
        """
        hpp::fcl::Plane normal. 

        :type: None
        """
    pass

class Quaternion(Boost.Python.instance):
    """
    Quaternion representing rotation.

    Supported operations ('q is a Quaternion, 'v' is a Vector3): 'q*q' (rotation composition), 'q*=q', 'q*v' (rotating 'v' by 'q'), 'q==q', 'q!=q', 'q[0..3]'.
    """
    @staticmethod
    def FromTwoVectors(a: object, b: object) -> Quaternion: 
        """
        FromTwoVectors( (object)a, (object)b) -> Quaternion :
            Returns the quaternion which transforms a into b through a rotation.

            C++ signature :
                Eigen::Quaternion<double, 0>* FromTwoVectors(Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @staticmethod
    def Identity() -> Quaternion: 
        """
        Identity() -> Quaternion :
            Returns a quaternion representing an identity rotation.

            C++ signature :
                Eigen::Quaternion<double, 0>* Identity()
        """
    @staticmethod
    def __abs__(arg1: Quaternion) -> float: 
        """
        __abs__( (Quaternion)arg1) -> float :

            C++ signature :
                double __abs__(Eigen::Quaternion<double, 0> {lvalue})
        """
    @staticmethod
    def __eq__(arg1: Quaternion, arg2: Quaternion) -> bool: 
        """
        __eq__( (Quaternion)arg1, (Quaternion)arg2) -> bool :

            C++ signature :
                bool __eq__(Eigen::Quaternion<double, 0>,Eigen::Quaternion<double, 0>)
        """
    @staticmethod
    def __getitem__(arg1: Quaternion, arg2: int) -> float: 
        """
        __getitem__( (Quaternion)arg1, (int)arg2) -> float :

            C++ signature :
                double __getitem__(Eigen::Quaternion<double, 0>,int)
        """
    @staticmethod
    def __imul__(arg1: object, arg2: Quaternion) -> object: 
        """
        __imul__( (object)arg1, (Quaternion)arg2) -> object :

            C++ signature :
                _object* __imul__(boost::python::back_reference<Eigen::Quaternion<double, 0>&>,Eigen::Quaternion<double, 0>)
        """
    @staticmethod
    @typing.overload
    def __init__(arg1: object) -> object: 
        """
        __init__( (object)self, (object)R) -> None :
            Initialize from rotation matrix.
            	R : a rotation matrix 3x3.

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 3, 0, 3, 3>)

            C++ signature :
                void __init__(_object*,Eigen::AngleAxis<double>)

            C++ signature :
                void __init__(_object*,Eigen::Quaternion<double, 0>)

            C++ signature :
                void* __init__(boost::python::api::object,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)

            C++ signature :
                void* __init__(boost::python::api::object,Eigen::Ref<Eigen::Matrix<double, 4, 1, 0, 4, 1>, 0, Eigen::InnerStride<1> >)

            C++ signature :
                void* __init__(boost::python::api::object)

            C++ signature :
                void __init__(_object*,double,double,double,double)
        """
    @staticmethod
    @typing.overload
    def __init__(arg1: object, u: object, v: object) -> object: ...
    @staticmethod
    @typing.overload
    def __init__(arg1: object, vec4: object) -> object: ...
    @typing.overload
    def __init__(self, R: object) -> None: ...
    @typing.overload
    def __init__(self, aa: AngleAxis) -> None: ...
    @typing.overload
    def __init__(self, quat: Quaternion) -> None: ...
    @typing.overload
    def __init__(self, w: float, x: float, y: float, z: float) -> None: ...
    @staticmethod
    def __len__() -> int: 
        """
        __len__() -> int :

            C++ signature :
                int __len__()
        """
    @staticmethod
    @typing.overload
    def __mul__(arg1: Quaternion, arg2: Quaternion) -> object: 
        """
        __mul__( (Quaternion)arg1, (Quaternion)arg2) -> object :

            C++ signature :
                _object* __mul__(Eigen::Quaternion<double, 0> {lvalue},Eigen::Quaternion<double, 0>)

            C++ signature :
                _object* __mul__(Eigen::Quaternion<double, 0> {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @staticmethod
    @typing.overload
    def __mul__(arg1: Quaternion, arg2: object) -> object: ...
    @staticmethod
    def __ne__(arg1: Quaternion, arg2: Quaternion) -> bool: 
        """
        __ne__( (Quaternion)arg1, (Quaternion)arg2) -> bool :

            C++ signature :
                bool __ne__(Eigen::Quaternion<double, 0>,Eigen::Quaternion<double, 0>)
        """
    @staticmethod
    def __repr__(arg1: Quaternion) -> str: 
        """
        __repr__( (Quaternion)arg1) -> str :

            C++ signature :
                std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> > __repr__(Eigen::Quaternion<double, 0>)
        """
    @staticmethod
    def __setitem__(arg1: Quaternion, arg2: int, arg3: float) -> None: 
        """
        __setitem__( (Quaternion)arg1, (int)arg2, (float)arg3) -> None :

            C++ signature :
                void __setitem__(Eigen::Quaternion<double, 0> {lvalue},int,double)
        """
    @staticmethod
    def __str__(arg1: Quaternion) -> str: 
        """
        __str__( (Quaternion)arg1) -> str :

            C++ signature :
                std::__cxx11::basic_string<char, std::char_traits<char>, std::allocator<char> > __str__(Eigen::Quaternion<double, 0>)
        """
    def _transformVector(self, vector: object) -> object: 
        """
        _transformVector( (Quaternion)self, (object)vector) -> object :
            Rotation of a vector by a quaternion.

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> _transformVector(Eigen::Quaternion<double, 0> {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @staticmethod
    def angularDistance(arg1: Quaternion, arg2: Quaternion) -> float: 
        """
        angularDistance( (Quaternion)arg1, (Quaternion)arg2) -> float :
            Returns the angle (in radian) between two rotations.

            C++ signature :
                double angularDistance(Eigen::Quaternion<double, 0> {lvalue},Eigen::QuaternionBase<Eigen::Quaternion<double, 0> >)
        """
    @typing.overload
    def assign(self, aa: AngleAxis) -> Quaternion: 
        """
        assign( (Quaternion)self, (Quaternion)quat) -> Quaternion :
            Set *this from an quaternion quat and returns a reference to *this.

            C++ signature :
                Eigen::Quaternion<double, 0> {lvalue} assign(Eigen::Quaternion<double, 0> {lvalue},Eigen::Quaternion<double, 0>)

            C++ signature :
                Eigen::Quaternion<double, 0> {lvalue} assign(Eigen::Quaternion<double, 0> {lvalue},Eigen::AngleAxis<double>)
        """
    @typing.overload
    def assign(self, quat: Quaternion) -> Quaternion: ...
    def coeffs(self) -> object: 
        """
        coeffs( (Quaternion)self) -> object :
            Returns a vector of the coefficients (x,y,z,w)

            C++ signature :
                Eigen::Matrix<double, 4, 1, 0, 4, 1> coeffs(Eigen::Quaternion<double, 0> {lvalue})
        """
    def conjugate(self) -> Quaternion: 
        """
        conjugate( (Quaternion)self) -> Quaternion :
            Returns the conjugated quaternion.
            The conjugate of a quaternion represents the opposite rotation.

            C++ signature :
                Eigen::Quaternion<double, 0> conjugate(Eigen::Quaternion<double, 0> {lvalue})
        """
    def dot(self, other: Quaternion) -> float: 
        """
        dot( (Quaternion)self, (Quaternion)other) -> float :
            Returns the dot product of *this with an other Quaternion.
            Geometrically speaking, the dot product of two unit quaternions corresponds to the cosine of half the angle between the two rotations.

            C++ signature :
                double dot(Eigen::Quaternion<double, 0> {lvalue},Eigen::QuaternionBase<Eigen::Quaternion<double, 0> >)
        """
    def inverse(self) -> Quaternion: 
        """
        inverse( (Quaternion)self) -> Quaternion :
            Returns the quaternion describing the inverse rotation.

            C++ signature :
                Eigen::Quaternion<double, 0> inverse(Eigen::Quaternion<double, 0> {lvalue})
        """
    def isApprox(self, other_: Quaternion, prec: float) -> bool: 
        """
        isApprox( (Quaternion)self, (Quaternion)other [, (float)prec]) -> bool :
            Returns true if *this is approximately equal to other, within the precision determined by prec.

            C++ signature :
                bool isApprox(Eigen::Quaternion<double, 0>,Eigen::Quaternion<double, 0> [,double])
        """
    def matrix(self) -> object: 
        """
        matrix( (Quaternion)self) -> object :
            Returns an equivalent 3x3 rotation matrix. Similar to toRotationMatrix.

            C++ signature :
                Eigen::Matrix<double, 3, 3, 0, 3, 3> matrix(Eigen::Quaternion<double, 0> {lvalue})
        """
    def norm(self) -> float: 
        """
        norm( (Quaternion)self) -> float :
            Returns the norm of the quaternion's coefficients.

            C++ signature :
                double norm(Eigen::Quaternion<double, 0> {lvalue})
        """
    def normalize(self) -> None: 
        """
        normalize( (Quaternion)self) -> None :
            Normalizes the quaternion *this.

            C++ signature :
                void normalize(Eigen::Quaternion<double, 0> {lvalue})
        """
    def normalized(self) -> Quaternion: 
        """
        normalized( (Quaternion)self) -> Quaternion :
            Returns a normalized copy of *this.

            C++ signature :
                Eigen::Quaternion<double, 0> normalized(Eigen::Quaternion<double, 0> {lvalue})
        """
    def setFromTwoVectors(self, a: object, b: object) -> Quaternion: 
        """
        setFromTwoVectors( (Quaternion)self, (object)a, (object)b) -> Quaternion :
            Set *this to be the quaternion which transforms a into b through a rotation.

            C++ signature :
                Eigen::Quaternion<double, 0> {lvalue} setFromTwoVectors(Eigen::Quaternion<double, 0> {lvalue},Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    def setIdentity(self) -> Quaternion: 
        """
        setIdentity( (Quaternion)self) -> Quaternion :
            Set *this to the idendity rotation.

            C++ signature :
                Eigen::Quaternion<double, 0> {lvalue} setIdentity(Eigen::Quaternion<double, 0> {lvalue})
        """
    def slerp(self, t: float, other: Quaternion) -> Quaternion: 
        """
        slerp( (Quaternion)self, (float)t, (Quaternion)other) -> Quaternion :
            Returns the spherical linear interpolation between the two quaternions *this and other at the parameter t in [0;1].

            C++ signature :
                Eigen::Quaternion<double, 0> slerp(Eigen::Quaternion<double, 0>,double,Eigen::Quaternion<double, 0>)
        """
    def squaredNorm(self) -> float: 
        """
        squaredNorm( (Quaternion)self) -> float :
            Returns the squared norm of the quaternion's coefficients.

            C++ signature :
                double squaredNorm(Eigen::Quaternion<double, 0> {lvalue})
        """
    @staticmethod
    def toRotationMatrix(arg1: Quaternion) -> object: 
        """
        toRotationMatrix( (Quaternion)arg1) -> object :
            Returns an equivalent 3x3 rotation matrix.

            C++ signature :
                Eigen::Matrix<double, 3, 3, 0, 3, 3> toRotationMatrix(Eigen::Quaternion<double, 0> {lvalue})
        """
    def vec(self) -> object: 
        """
        vec( (Quaternion)self) -> object :
            Returns a vector expression of the imaginary part (x,y,z).

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> vec(Eigen::Quaternion<double, 0>)
        """
    @property
    def w(self) -> None:
        """
        The w coefficient.

        :type: None
        """
    @property
    def x(self) -> None:
        """
        The x coefficient.

        :type: None
        """
    @property
    def y(self) -> None:
        """
        The y coefficient.

        :type: None
        """
    @property
    def z(self) -> None:
        """
        The z coefficient.

        :type: None
        """
    pass

class CollisionRequest(QueryRequest, Boost.Python.instance):
    """
    request to the collision algorithm 
    """
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :
            Default constructor. 

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,hpp::fcl::CollisionRequestFlag,unsigned long)
        """
    @typing.overload
    def __init__(self, flag: CollisionRequestFlag, num_max_contacts_: int) -> None: ...
    @property
    def break_distance(self) -> None:
        """
        Distance below which bounding volumes are broken down. See Collision detection and distance lower bound. 

        :type: None
        """
    @property
    def distance_upper_bound(self) -> None:
        """
        Distance above which GJK solver makes an early stopping. GJK stops searching for the closest points when it proves that the distance between two geometries is above this threshold. 

        Remark: Consequently, the closest points might be incorrect, but allows to save computational ressources. 

        :type: None
        """
    @property
    def enable_contact(self) -> None:
        """
        whether the contact information (normal, penetration depth and contact position) will return 

        :type: None
        """
    @property
    def enable_distance_lower_bound(self) -> None:
        """
        Whether a lower bound on distance is returned when objects are disjoint. 

        :type: None
        """
    @property
    def num_max_contacts(self) -> None:
        """
        The maximum number of contacts will return. 

        :type: None
        """
    @property
    def security_margin(self) -> None:
        """
        Distance below which objects are considered in collision. See Collision detection and distance lower bound. 

        :type: None
        """
    pass

class CollisionResult(QueryResult, Boost.Python.instance):
    """
    collision result 
    """
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :

            C++ signature :
                void __init__(_object*)
        """
    def addContact(self, c: Contact) -> None: 
        """
        addContact( (CollisionResult)self, (Contact)c) -> None :
            add one contact into result structure 

            C++ signature :
                void addContact(hpp::fcl::CollisionResult {lvalue},hpp::fcl::Contact)
        """
    def clear(self) -> None: 
        """
        clear( (CollisionResult)self) -> None :
            clear the results obtained 

            C++ signature :
                void clear(hpp::fcl::CollisionResult {lvalue})
        """
    @staticmethod
    def getContact(arg1: CollisionResult, arg2: int) -> Contact: 
        """
        getContact( (CollisionResult)arg1, (int)arg2) -> Contact :
            get the i-th contact calculated 

            C++ signature :
                hpp::fcl::Contact getContact(hpp::fcl::CollisionResult {lvalue},unsigned long)
        """
    @staticmethod
    @typing.overload
    def getContacts(arg1: CollisionResult) -> StdVec_Contact: 
        """
        getContacts( (CollisionResult)self, (StdVec_Contact)contacts_) -> None :
            get all the contacts 

            C++ signature :
                void getContacts(hpp::fcl::CollisionResult {lvalue},std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> > {lvalue})

            C++ signature :
                std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> > getContacts(hpp::fcl::CollisionResult {lvalue})
        """
    @typing.overload
    def getContacts(self, contacts_: StdVec_Contact) -> None: ...
    def isCollision(self) -> bool: 
        """
        isCollision( (CollisionResult)self) -> bool :
            return binary collision result 

            C++ signature :
                bool isCollision(hpp::fcl::CollisionResult {lvalue})
        """
    def numContacts(self) -> int: 
        """
        numContacts( (CollisionResult)self) -> int :
            number of contacts found 

            C++ signature :
                unsigned long numContacts(hpp::fcl::CollisionResult {lvalue})
        """
    @property
    def distance_lower_bound(self) -> None:
        """
        Lower bound on distance between objects if they are disjoint. See Collision detection and distance lower bound Note: computed only on request (or if it does not add any computational overhead). 

        :type: None
        """
    pass

class Box(ShapeBase, CollisionGeometry, Boost.Python.instance):
    """
    Base class for all basic geometric shapes. 
    """
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,double,double,double)

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @typing.overload
    def __init__(self, side_: object) -> None: ...
    @typing.overload
    def __init__(self, x: float, y: float, z: float) -> None: ...
    @staticmethod
    def clone(arg1: Box) -> Box: 
        """
        clone( (Box)arg1) -> Box :
            Clone *this into a new hpp::fcl::Box. 

            C++ signature :
                hpp::fcl::Box* clone(hpp::fcl::Box {lvalue})
        """
    @property
    def halfSide(self) -> None:
        """
        box side half-length 

        :type: None
        """
    pass

class Sphere(ShapeBase, CollisionGeometry, Boost.Python.instance):
    """
    Center at zero point sphere. 
    """
    def __init__(self, radius_: float) -> None: 
        """
        __init__( (object)self, (float)radius_) -> None :

            C++ signature :
                void __init__(_object*,double)
        """
    @staticmethod
    def clone(arg1: Sphere) -> Sphere: 
        """
        clone( (Sphere)arg1) -> Sphere :
            Clone *this into a new hpp::fcl::Sphere. 

            C++ signature :
                hpp::fcl::Sphere* clone(hpp::fcl::Sphere {lvalue})
        """
    @property
    def radius(self) -> None:
        """
        Radius of the sphere. 

        :type: None
        """
    pass

class StdVec_CollisionRequest(Boost.Python.instance):
    @staticmethod
    def __contains__(arg1: StdVec_CollisionRequest, arg2: object) -> bool: 
        """
        __contains__( (StdVec_CollisionRequest)arg1, (object)arg2) -> bool :

            C++ signature :
                bool __contains__(std::vector<hpp::fcl::CollisionRequest, std::allocator<hpp::fcl::CollisionRequest> > {lvalue},_object*)
        """
    @staticmethod
    def __delitem__(arg1: StdVec_CollisionRequest, arg2: object) -> None: 
        """
        __delitem__( (StdVec_CollisionRequest)arg1, (object)arg2) -> None :

            C++ signature :
                void __delitem__(std::vector<hpp::fcl::CollisionRequest, std::allocator<hpp::fcl::CollisionRequest> > {lvalue},_object*)
        """
    @staticmethod
    def __getitem__(arg1: object, arg2: object) -> object: 
        """
        __getitem__( (object)arg1, (object)arg2) -> object :

            C++ signature :
                boost::python::api::object __getitem__(boost::python::back_reference<std::vector<hpp::fcl::CollisionRequest, std::allocator<hpp::fcl::CollisionRequest> >&>,_object*)
        """
    @staticmethod
    def __init__(arg1: object) -> None: 
        """
        __init__( (object)arg1) -> None :

            C++ signature :
                void __init__(_object*)
        """
    @staticmethod
    def __iter__(arg1: object) -> object: 
        """
        __iter__( (object)arg1) -> object :

            C++ signature :
                boost::python::objects::iterator_range<boost::python::return_internal_reference<1ul, boost::python::default_call_policies>, __gnu_cxx::__normal_iterator<hpp::fcl::CollisionRequest*, std::vector<hpp::fcl::CollisionRequest, std::allocator<hpp::fcl::CollisionRequest> > > > __iter__(boost::python::back_reference<std::vector<hpp::fcl::CollisionRequest, std::allocator<hpp::fcl::CollisionRequest> >&>)
        """
    @staticmethod
    def __len__(arg1: StdVec_CollisionRequest) -> int: 
        """
        __len__( (StdVec_CollisionRequest)arg1) -> int :

            C++ signature :
                unsigned long __len__(std::vector<hpp::fcl::CollisionRequest, std::allocator<hpp::fcl::CollisionRequest> > {lvalue})
        """
    @staticmethod
    def __setitem__(arg1: StdVec_CollisionRequest, arg2: object, arg3: object) -> None: 
        """
        __setitem__( (StdVec_CollisionRequest)arg1, (object)arg2, (object)arg3) -> None :

            C++ signature :
                void __setitem__(std::vector<hpp::fcl::CollisionRequest, std::allocator<hpp::fcl::CollisionRequest> > {lvalue},_object*,_object*)
        """
    @staticmethod
    def append(arg1: StdVec_CollisionRequest, arg2: object) -> None: 
        """
        append( (StdVec_CollisionRequest)arg1, (object)arg2) -> None :

            C++ signature :
                void append(std::vector<hpp::fcl::CollisionRequest, std::allocator<hpp::fcl::CollisionRequest> > {lvalue},boost::python::api::object)
        """
    @staticmethod
    def extend(arg1: StdVec_CollisionRequest, arg2: object) -> None: 
        """
        extend( (StdVec_CollisionRequest)arg1, (object)arg2) -> None :

            C++ signature :
                void extend(std::vector<hpp::fcl::CollisionRequest, std::allocator<hpp::fcl::CollisionRequest> > {lvalue},boost::python::api::object)
        """
    __instance_size__ = 40
    pass

class StdVec_CollisionResult(Boost.Python.instance):
    @staticmethod
    def __contains__(arg1: StdVec_CollisionResult, arg2: object) -> bool: 
        """
        __contains__( (StdVec_CollisionResult)arg1, (object)arg2) -> bool :

            C++ signature :
                bool __contains__(std::vector<hpp::fcl::CollisionResult, std::allocator<hpp::fcl::CollisionResult> > {lvalue},_object*)
        """
    @staticmethod
    def __delitem__(arg1: StdVec_CollisionResult, arg2: object) -> None: 
        """
        __delitem__( (StdVec_CollisionResult)arg1, (object)arg2) -> None :

            C++ signature :
                void __delitem__(std::vector<hpp::fcl::CollisionResult, std::allocator<hpp::fcl::CollisionResult> > {lvalue},_object*)
        """
    @staticmethod
    def __getitem__(arg1: object, arg2: object) -> object: 
        """
        __getitem__( (object)arg1, (object)arg2) -> object :

            C++ signature :
                boost::python::api::object __getitem__(boost::python::back_reference<std::vector<hpp::fcl::CollisionResult, std::allocator<hpp::fcl::CollisionResult> >&>,_object*)
        """
    @staticmethod
    def __init__(arg1: object) -> None: 
        """
        __init__( (object)arg1) -> None :

            C++ signature :
                void __init__(_object*)
        """
    @staticmethod
    def __iter__(arg1: object) -> object: 
        """
        __iter__( (object)arg1) -> object :

            C++ signature :
                boost::python::objects::iterator_range<boost::python::return_internal_reference<1ul, boost::python::default_call_policies>, __gnu_cxx::__normal_iterator<hpp::fcl::CollisionResult*, std::vector<hpp::fcl::CollisionResult, std::allocator<hpp::fcl::CollisionResult> > > > __iter__(boost::python::back_reference<std::vector<hpp::fcl::CollisionResult, std::allocator<hpp::fcl::CollisionResult> >&>)
        """
    @staticmethod
    def __len__(arg1: StdVec_CollisionResult) -> int: 
        """
        __len__( (StdVec_CollisionResult)arg1) -> int :

            C++ signature :
                unsigned long __len__(std::vector<hpp::fcl::CollisionResult, std::allocator<hpp::fcl::CollisionResult> > {lvalue})
        """
    @staticmethod
    def __setitem__(arg1: StdVec_CollisionResult, arg2: object, arg3: object) -> None: 
        """
        __setitem__( (StdVec_CollisionResult)arg1, (object)arg2, (object)arg3) -> None :

            C++ signature :
                void __setitem__(std::vector<hpp::fcl::CollisionResult, std::allocator<hpp::fcl::CollisionResult> > {lvalue},_object*,_object*)
        """
    @staticmethod
    def append(arg1: StdVec_CollisionResult, arg2: object) -> None: 
        """
        append( (StdVec_CollisionResult)arg1, (object)arg2) -> None :

            C++ signature :
                void append(std::vector<hpp::fcl::CollisionResult, std::allocator<hpp::fcl::CollisionResult> > {lvalue},boost::python::api::object)
        """
    @staticmethod
    def extend(arg1: StdVec_CollisionResult, arg2: object) -> None: 
        """
        extend( (StdVec_CollisionResult)arg1, (object)arg2) -> None :

            C++ signature :
                void extend(std::vector<hpp::fcl::CollisionResult, std::allocator<hpp::fcl::CollisionResult> > {lvalue},boost::python::api::object)
        """
    __instance_size__ = 40
    pass

class StdVec_Contact(Boost.Python.instance):
    @staticmethod
    def __contains__(arg1: StdVec_Contact, arg2: object) -> bool: 
        """
        __contains__( (StdVec_Contact)arg1, (object)arg2) -> bool :

            C++ signature :
                bool __contains__(std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> > {lvalue},_object*)
        """
    @staticmethod
    def __delitem__(arg1: StdVec_Contact, arg2: object) -> None: 
        """
        __delitem__( (StdVec_Contact)arg1, (object)arg2) -> None :

            C++ signature :
                void __delitem__(std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> > {lvalue},_object*)
        """
    @staticmethod
    def __getitem__(arg1: object, arg2: object) -> object: 
        """
        __getitem__( (object)arg1, (object)arg2) -> object :

            C++ signature :
                boost::python::api::object __getitem__(boost::python::back_reference<std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> >&>,_object*)
        """
    @staticmethod
    def __init__(arg1: object) -> None: 
        """
        __init__( (object)arg1) -> None :

            C++ signature :
                void __init__(_object*)
        """
    @staticmethod
    def __iter__(arg1: object) -> object: 
        """
        __iter__( (object)arg1) -> object :

            C++ signature :
                boost::python::objects::iterator_range<boost::python::return_internal_reference<1ul, boost::python::default_call_policies>, __gnu_cxx::__normal_iterator<hpp::fcl::Contact*, std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> > > > __iter__(boost::python::back_reference<std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> >&>)
        """
    @staticmethod
    def __len__(arg1: StdVec_Contact) -> int: 
        """
        __len__( (StdVec_Contact)arg1) -> int :

            C++ signature :
                unsigned long __len__(std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> > {lvalue})
        """
    @staticmethod
    def __setitem__(arg1: StdVec_Contact, arg2: object, arg3: object) -> None: 
        """
        __setitem__( (StdVec_Contact)arg1, (object)arg2, (object)arg3) -> None :

            C++ signature :
                void __setitem__(std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> > {lvalue},_object*,_object*)
        """
    @staticmethod
    def append(arg1: StdVec_Contact, arg2: object) -> None: 
        """
        append( (StdVec_Contact)arg1, (object)arg2) -> None :

            C++ signature :
                void append(std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> > {lvalue},boost::python::api::object)
        """
    @staticmethod
    def extend(arg1: StdVec_Contact, arg2: object) -> None: 
        """
        extend( (StdVec_Contact)arg1, (object)arg2) -> None :

            C++ signature :
                void extend(std::vector<hpp::fcl::Contact, std::allocator<hpp::fcl::Contact> > {lvalue},boost::python::api::object)
        """
    __instance_size__ = 40
    pass

class StdVec_DistanceRequest(Boost.Python.instance):
    @staticmethod
    def __contains__(arg1: StdVec_DistanceRequest, arg2: object) -> bool: 
        """
        __contains__( (StdVec_DistanceRequest)arg1, (object)arg2) -> bool :

            C++ signature :
                bool __contains__(std::vector<hpp::fcl::DistanceRequest, std::allocator<hpp::fcl::DistanceRequest> > {lvalue},_object*)
        """
    @staticmethod
    def __delitem__(arg1: StdVec_DistanceRequest, arg2: object) -> None: 
        """
        __delitem__( (StdVec_DistanceRequest)arg1, (object)arg2) -> None :

            C++ signature :
                void __delitem__(std::vector<hpp::fcl::DistanceRequest, std::allocator<hpp::fcl::DistanceRequest> > {lvalue},_object*)
        """
    @staticmethod
    def __getitem__(arg1: object, arg2: object) -> object: 
        """
        __getitem__( (object)arg1, (object)arg2) -> object :

            C++ signature :
                boost::python::api::object __getitem__(boost::python::back_reference<std::vector<hpp::fcl::DistanceRequest, std::allocator<hpp::fcl::DistanceRequest> >&>,_object*)
        """
    @staticmethod
    def __init__(arg1: object) -> None: 
        """
        __init__( (object)arg1) -> None :

            C++ signature :
                void __init__(_object*)
        """
    @staticmethod
    def __iter__(arg1: object) -> object: 
        """
        __iter__( (object)arg1) -> object :

            C++ signature :
                boost::python::objects::iterator_range<boost::python::return_internal_reference<1ul, boost::python::default_call_policies>, __gnu_cxx::__normal_iterator<hpp::fcl::DistanceRequest*, std::vector<hpp::fcl::DistanceRequest, std::allocator<hpp::fcl::DistanceRequest> > > > __iter__(boost::python::back_reference<std::vector<hpp::fcl::DistanceRequest, std::allocator<hpp::fcl::DistanceRequest> >&>)
        """
    @staticmethod
    def __len__(arg1: StdVec_DistanceRequest) -> int: 
        """
        __len__( (StdVec_DistanceRequest)arg1) -> int :

            C++ signature :
                unsigned long __len__(std::vector<hpp::fcl::DistanceRequest, std::allocator<hpp::fcl::DistanceRequest> > {lvalue})
        """
    @staticmethod
    def __setitem__(arg1: StdVec_DistanceRequest, arg2: object, arg3: object) -> None: 
        """
        __setitem__( (StdVec_DistanceRequest)arg1, (object)arg2, (object)arg3) -> None :

            C++ signature :
                void __setitem__(std::vector<hpp::fcl::DistanceRequest, std::allocator<hpp::fcl::DistanceRequest> > {lvalue},_object*,_object*)
        """
    @staticmethod
    def append(arg1: StdVec_DistanceRequest, arg2: object) -> None: 
        """
        append( (StdVec_DistanceRequest)arg1, (object)arg2) -> None :

            C++ signature :
                void append(std::vector<hpp::fcl::DistanceRequest, std::allocator<hpp::fcl::DistanceRequest> > {lvalue},boost::python::api::object)
        """
    @staticmethod
    def extend(arg1: StdVec_DistanceRequest, arg2: object) -> None: 
        """
        extend( (StdVec_DistanceRequest)arg1, (object)arg2) -> None :

            C++ signature :
                void extend(std::vector<hpp::fcl::DistanceRequest, std::allocator<hpp::fcl::DistanceRequest> > {lvalue},boost::python::api::object)
        """
    __instance_size__ = 40
    pass

class StdVec_DistanceResult(Boost.Python.instance):
    @staticmethod
    def __contains__(arg1: StdVec_DistanceResult, arg2: object) -> bool: 
        """
        __contains__( (StdVec_DistanceResult)arg1, (object)arg2) -> bool :

            C++ signature :
                bool __contains__(std::vector<hpp::fcl::DistanceResult, std::allocator<hpp::fcl::DistanceResult> > {lvalue},_object*)
        """
    @staticmethod
    def __delitem__(arg1: StdVec_DistanceResult, arg2: object) -> None: 
        """
        __delitem__( (StdVec_DistanceResult)arg1, (object)arg2) -> None :

            C++ signature :
                void __delitem__(std::vector<hpp::fcl::DistanceResult, std::allocator<hpp::fcl::DistanceResult> > {lvalue},_object*)
        """
    @staticmethod
    def __getitem__(arg1: object, arg2: object) -> object: 
        """
        __getitem__( (object)arg1, (object)arg2) -> object :

            C++ signature :
                boost::python::api::object __getitem__(boost::python::back_reference<std::vector<hpp::fcl::DistanceResult, std::allocator<hpp::fcl::DistanceResult> >&>,_object*)
        """
    @staticmethod
    def __init__(arg1: object) -> None: 
        """
        __init__( (object)arg1) -> None :

            C++ signature :
                void __init__(_object*)
        """
    @staticmethod
    def __iter__(arg1: object) -> object: 
        """
        __iter__( (object)arg1) -> object :

            C++ signature :
                boost::python::objects::iterator_range<boost::python::return_internal_reference<1ul, boost::python::default_call_policies>, __gnu_cxx::__normal_iterator<hpp::fcl::DistanceResult*, std::vector<hpp::fcl::DistanceResult, std::allocator<hpp::fcl::DistanceResult> > > > __iter__(boost::python::back_reference<std::vector<hpp::fcl::DistanceResult, std::allocator<hpp::fcl::DistanceResult> >&>)
        """
    @staticmethod
    def __len__(arg1: StdVec_DistanceResult) -> int: 
        """
        __len__( (StdVec_DistanceResult)arg1) -> int :

            C++ signature :
                unsigned long __len__(std::vector<hpp::fcl::DistanceResult, std::allocator<hpp::fcl::DistanceResult> > {lvalue})
        """
    @staticmethod
    def __setitem__(arg1: StdVec_DistanceResult, arg2: object, arg3: object) -> None: 
        """
        __setitem__( (StdVec_DistanceResult)arg1, (object)arg2, (object)arg3) -> None :

            C++ signature :
                void __setitem__(std::vector<hpp::fcl::DistanceResult, std::allocator<hpp::fcl::DistanceResult> > {lvalue},_object*,_object*)
        """
    @staticmethod
    def append(arg1: StdVec_DistanceResult, arg2: object) -> None: 
        """
        append( (StdVec_DistanceResult)arg1, (object)arg2) -> None :

            C++ signature :
                void append(std::vector<hpp::fcl::DistanceResult, std::allocator<hpp::fcl::DistanceResult> > {lvalue},boost::python::api::object)
        """
    @staticmethod
    def extend(arg1: StdVec_DistanceResult, arg2: object) -> None: 
        """
        extend( (StdVec_DistanceResult)arg1, (object)arg2) -> None :

            C++ signature :
                void extend(std::vector<hpp::fcl::DistanceResult, std::allocator<hpp::fcl::DistanceResult> > {lvalue},boost::python::api::object)
        """
    __instance_size__ = 40
    pass

class StdVec_Triangle(Boost.Python.instance):
    @staticmethod
    def __contains__(arg1: StdVec_Triangle, arg2: object) -> bool: 
        """
        __contains__( (StdVec_Triangle)arg1, (object)arg2) -> bool :

            C++ signature :
                bool __contains__(std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> > {lvalue},_object*)
        """
    @staticmethod
    def __delitem__(arg1: StdVec_Triangle, arg2: object) -> None: 
        """
        __delitem__( (StdVec_Triangle)arg1, (object)arg2) -> None :

            C++ signature :
                void __delitem__(std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> > {lvalue},_object*)
        """
    @staticmethod
    def __getitem__(arg1: object, arg2: object) -> object: 
        """
        __getitem__( (object)arg1, (object)arg2) -> object :

            C++ signature :
                boost::python::api::object __getitem__(boost::python::back_reference<std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> >&>,_object*)
        """
    @staticmethod
    def __init__(arg1: object) -> None: 
        """
        __init__( (object)arg1) -> None :

            C++ signature :
                void __init__(_object*)
        """
    @staticmethod
    def __iter__(arg1: object) -> object: 
        """
        __iter__( (object)arg1) -> object :

            C++ signature :
                boost::python::objects::iterator_range<boost::python::return_internal_reference<1ul, boost::python::default_call_policies>, __gnu_cxx::__normal_iterator<hpp::fcl::Triangle*, std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> > > > __iter__(boost::python::back_reference<std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> >&>)
        """
    @staticmethod
    def __len__(arg1: StdVec_Triangle) -> int: 
        """
        __len__( (StdVec_Triangle)arg1) -> int :

            C++ signature :
                unsigned long __len__(std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> > {lvalue})
        """
    @staticmethod
    def __setitem__(arg1: StdVec_Triangle, arg2: object, arg3: object) -> None: 
        """
        __setitem__( (StdVec_Triangle)arg1, (object)arg2, (object)arg3) -> None :

            C++ signature :
                void __setitem__(std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> > {lvalue},_object*,_object*)
        """
    @staticmethod
    def append(arg1: StdVec_Triangle, arg2: object) -> None: 
        """
        append( (StdVec_Triangle)arg1, (object)arg2) -> None :

            C++ signature :
                void append(std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> > {lvalue},boost::python::api::object)
        """
    @staticmethod
    def extend(arg1: StdVec_Triangle, arg2: object) -> None: 
        """
        extend( (StdVec_Triangle)arg1, (object)arg2) -> None :

            C++ signature :
                void extend(std::vector<hpp::fcl::Triangle, std::allocator<hpp::fcl::Triangle> > {lvalue},boost::python::api::object)
        """
    __instance_size__ = 40
    pass

class StdVec_Vec3f(Boost.Python.instance):
    @staticmethod
    def __contains__(arg1: StdVec_Vec3f, arg2: object) -> bool: 
        """
        __contains__( (StdVec_Vec3f)arg1, (object)arg2) -> bool :

            C++ signature :
                bool __contains__(std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > > {lvalue},_object*)
        """
    @staticmethod
    def __delitem__(arg1: StdVec_Vec3f, arg2: object) -> None: 
        """
        __delitem__( (StdVec_Vec3f)arg1, (object)arg2) -> None :

            C++ signature :
                void __delitem__(std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > > {lvalue},_object*)
        """
    @staticmethod
    def __getitem__(arg1: object, arg2: object) -> object: 
        """
        __getitem__( (object)arg1, (object)arg2) -> object :

            C++ signature :
                boost::python::api::object __getitem__(boost::python::back_reference<std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > >&>,_object*)
        """
    @staticmethod
    def __init__(arg1: object) -> None: 
        """
        __init__( (object)arg1) -> None :

            C++ signature :
                void __init__(_object*)
        """
    @staticmethod
    def __iter__(arg1: object) -> object: 
        """
        __iter__( (object)arg1) -> object :

            C++ signature :
                boost::python::objects::iterator_range<boost::python::return_internal_reference<1ul, boost::python::default_call_policies>, __gnu_cxx::__normal_iterator<Eigen::Matrix<double, 3, 1, 0, 3, 1>*, std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > > > > __iter__(boost::python::back_reference<std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > >&>)
        """
    @staticmethod
    def __len__(arg1: StdVec_Vec3f) -> int: 
        """
        __len__( (StdVec_Vec3f)arg1) -> int :

            C++ signature :
                unsigned long __len__(std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > > {lvalue})
        """
    @staticmethod
    def __setitem__(arg1: StdVec_Vec3f, arg2: object, arg3: object) -> None: 
        """
        __setitem__( (StdVec_Vec3f)arg1, (object)arg2, (object)arg3) -> None :

            C++ signature :
                void __setitem__(std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > > {lvalue},_object*,_object*)
        """
    @staticmethod
    def append(arg1: StdVec_Vec3f, arg2: object) -> None: 
        """
        append( (StdVec_Vec3f)arg1, (object)arg2) -> None :

            C++ signature :
                void append(std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > > {lvalue},boost::python::api::object)
        """
    @staticmethod
    def extend(arg1: StdVec_Vec3f, arg2: object) -> None: 
        """
        extend( (StdVec_Vec3f)arg1, (object)arg2) -> None :

            C++ signature :
                void extend(std::vector<Eigen::Matrix<double, 3, 1, 0, 3, 1>, std::allocator<Eigen::Matrix<double, 3, 1, 0, 3, 1> > > {lvalue},boost::python::api::object)
        """
    __instance_size__ = 40
    pass

class Transform3f(Boost.Python.instance):
    """
    Simple transform class used locally by InterpMotion. 
    """
    @staticmethod
    def __eq__(arg1: Transform3f, arg2: Transform3f) -> object: 
        """
        __eq__( (Transform3f)arg1, (Transform3f)arg2) -> object :

            C++ signature :
                _object* __eq__(hpp::fcl::Transform3f {lvalue},hpp::fcl::Transform3f)
        """
    @staticmethod
    def __imul__(arg1: object, arg2: Transform3f) -> object: 
        """
        __imul__( (object)arg1, (Transform3f)arg2) -> object :

            C++ signature :
                _object* __imul__(boost::python::back_reference<hpp::fcl::Transform3f&>,hpp::fcl::Transform3f)
        """
    @typing.overload
    def __init__(self) -> None: 
        """
        __init__( (object)self) -> None :
            Default transform is no movement. 

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,Eigen::MatrixBase<Eigen::Matrix<double, 3, 3, 0, 3, 3> >,Eigen::MatrixBase<Eigen::Matrix<double, 3, 1, 0, 3, 1> >)

            C++ signature :
                void __init__(_object*,Eigen::Quaternion<double, 0>,Eigen::MatrixBase<Eigen::Matrix<double, 3, 1, 0, 3, 1> >)

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 3, 0, 3, 3>)

            C++ signature :
                void __init__(_object*,Eigen::Quaternion<double, 0>)

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 1, 0, 3, 1>)

            C++ signature :
                void __init__(_object*,hpp::fcl::Transform3f)
        """
    @typing.overload
    def __init__(self, R_: object) -> None: ...
    @typing.overload
    def __init__(self, R_: object, T_: object) -> None: ...
    @typing.overload
    def __init__(self, T_: object) -> None: ...
    @typing.overload
    def __init__(self, q_: Quaternion) -> None: ...
    @typing.overload
    def __init__(self, q_: Quaternion, T_: object) -> None: ...
    @typing.overload
    def __init__(self, tf: Transform3f) -> None: ...
    @staticmethod
    def __mul__(arg1: Transform3f, arg2: Transform3f) -> object: 
        """
        __mul__( (Transform3f)arg1, (Transform3f)arg2) -> object :

            C++ signature :
                _object* __mul__(hpp::fcl::Transform3f {lvalue},hpp::fcl::Transform3f)
        """
    @staticmethod
    def __ne__(arg1: Transform3f, arg2: Transform3f) -> object: 
        """
        __ne__( (Transform3f)arg1, (Transform3f)arg2) -> object :

            C++ signature :
                _object* __ne__(hpp::fcl::Transform3f {lvalue},hpp::fcl::Transform3f)
        """
    def getQuatRotation(self) -> Quaternion: 
        """
        getQuatRotation( (Transform3f)self) -> Quaternion :
            get quaternion 

            C++ signature :
                Eigen::Quaternion<double, 0> getQuatRotation(hpp::fcl::Transform3f {lvalue})
        """
    @staticmethod
    def getRotation(arg1: Transform3f) -> object: 
        """
        getRotation( (Transform3f)arg1) -> object :

            C++ signature :
                Eigen::Matrix<double, 3, 3, 0, 3, 3> getRotation(hpp::fcl::Transform3f {lvalue})
        """
    @staticmethod
    def getTranslation(arg1: Transform3f) -> object: 
        """
        getTranslation( (Transform3f)arg1) -> object :
            get translation 

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> getTranslation(hpp::fcl::Transform3f {lvalue})
        """
    def inverse(self) -> Transform3f: 
        """
        inverse( (Transform3f)self) -> Transform3f :
            inverse transform 

            C++ signature :
                hpp::fcl::Transform3f inverse(hpp::fcl::Transform3f {lvalue})
        """
    @staticmethod
    def inverseInPlace(arg1: Transform3f) -> Transform3f: 
        """
        inverseInPlace( (Transform3f)arg1) -> Transform3f :
            inverse transform 

            C++ signature :
                hpp::fcl::Transform3f {lvalue} inverseInPlace(hpp::fcl::Transform3f {lvalue})
        """
    def inverseTimes(self, other: Transform3f) -> Transform3f: 
        """
        inverseTimes( (Transform3f)self, (Transform3f)other) -> Transform3f :
            inverse the transform and multiply with another 

            C++ signature :
                hpp::fcl::Transform3f inverseTimes(hpp::fcl::Transform3f {lvalue},hpp::fcl::Transform3f)
        """
    def isIdentity(self) -> bool: 
        """
        isIdentity( (Transform3f)self) -> bool :
            check whether the transform is identity 

            C++ signature :
                bool isIdentity(hpp::fcl::Transform3f {lvalue})
        """
    def setIdentity(self) -> None: 
        """
        setIdentity( (Transform3f)self) -> None :
            set the transform to be identity transform 

            C++ signature :
                void setIdentity(hpp::fcl::Transform3f {lvalue})
        """
    def setQuatRotation(self, q_: Quaternion) -> None: 
        """
        setQuatRotation( (Transform3f)self, (Quaternion)q_) -> None :
            set transform from rotation 

            C++ signature :
                void setQuatRotation(hpp::fcl::Transform3f {lvalue},Eigen::Quaternion<double, 0>)
        """
    @staticmethod
    def setRotation(arg1: Transform3f, arg2: object) -> None: 
        """
        setRotation( (Transform3f)arg1, (object)arg2) -> None :

            C++ signature :
                void setRotation(hpp::fcl::Transform3f {lvalue},Eigen::MatrixBase<Eigen::Matrix<double, 3, 3, 0, 3, 3> >)
        """
    @typing.overload
    def setTransform(self, R_: object, T_: object) -> None: 
        """
        setTransform( (Transform3f)self, (object)R_, (object)T_) -> None :
            set transform from rotation and translation 

            C++ signature :
                void setTransform(hpp::fcl::Transform3f {lvalue},Eigen::MatrixBase<Eigen::Matrix<double, 3, 3, 0, 3, 3> >,Eigen::MatrixBase<Eigen::Matrix<double, 3, 1, 0, 3, 1> >)

            C++ signature :
                void setTransform(hpp::fcl::Transform3f {lvalue},Eigen::Quaternion<double, 0>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @typing.overload
    def setTransform(self, q_: Quaternion, T_: object) -> None: ...
    @staticmethod
    def setTranslation(arg1: Transform3f, arg2: object) -> None: 
        """
        setTranslation( (Transform3f)arg1, (object)arg2) -> None :

            C++ signature :
                void setTranslation(hpp::fcl::Transform3f {lvalue},Eigen::MatrixBase<Eigen::Matrix<double, 3, 1, 0, 3, 1> >)
        """
    def transform(self, v: object) -> object: 
        """
        transform( (Transform3f)self, (object)v) -> object :
            transform a given vector by the transform 

            C++ signature :
                Eigen::Matrix<double, 3, 1, 0, 3, 1> transform(hpp::fcl::Transform3f {lvalue},Eigen::MatrixBase<Eigen::Matrix<double, 3, 1, 0, 3, 1> >)
        """
    pass

class Triangle(Boost.Python.instance):
    @staticmethod
    def __eq__(arg1: Triangle, arg2: Triangle) -> object: 
        """
        __eq__( (Triangle)arg1, (Triangle)arg2) -> object :

            C++ signature :
                _object* __eq__(hpp::fcl::Triangle {lvalue},hpp::fcl::Triangle)
        """
    @staticmethod
    def __getitem__(arg1: Triangle, arg2: int) -> int: 
        """
        __getitem__( (Triangle)arg1, (int)arg2) -> int :

            C++ signature :
                unsigned long __getitem__(hpp::fcl::Triangle,int)
        """
    @staticmethod
    @typing.overload
    def __init__(arg1: object) -> None: 
        """
        __init__( (object)arg1) -> None :

            C++ signature :
                void __init__(_object*)

            C++ signature :
                void __init__(_object*,unsigned long,unsigned long,unsigned long)
        """
    @staticmethod
    @typing.overload
    def __init__(arg1: object, arg2: int, arg3: int, arg4: int) -> None: ...
    @staticmethod
    def __setitem__(arg1: Triangle, arg2: int, arg3: int) -> None: 
        """
        __setitem__( (Triangle)arg1, (int)arg2, (int)arg3) -> None :

            C++ signature :
                void __setitem__(hpp::fcl::Triangle {lvalue},int,unsigned long)
        """
    @staticmethod
    def set(arg1: Triangle, arg2: int, arg3: int, arg4: int) -> None: 
        """
        set( (Triangle)arg1, (int)arg2, (int)arg3, (int)arg4) -> None :

            C++ signature :
                void set(hpp::fcl::Triangle {lvalue},unsigned long,unsigned long,unsigned long)
        """
    @staticmethod
    def size() -> int: 
        """
        size() -> int :

            C++ signature :
                int size()
        """
    pass

class TriangleP(ShapeBase, CollisionGeometry, Boost.Python.instance):
    """
    hpp::fcl::Triangle stores the points instead of only indices of points. 
    """
    def __init__(self, a_: object, b_: object, c_: object) -> None: 
        """
        __init__( (object)self, (object)a_, (object)b_, (object)c_) -> None :

            C++ signature :
                void __init__(_object*,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>,Eigen::Matrix<double, 3, 1, 0, 3, 1>)
        """
    @staticmethod
    def clone(arg1: TriangleP) -> TriangleP: 
        """
        clone( (TriangleP)arg1) -> TriangleP :
            Clone *this into a new hpp::fcl::TriangleP. 

            C++ signature :
                hpp::fcl::TriangleP* clone(hpp::fcl::TriangleP {lvalue})
        """
    @property
    def a(self) -> None:
        """
        :type: None
        """
    @property
    def b(self) -> None:
        """
        :type: None
        """
    @property
    def c(self) -> None:
        """
        :type: None
        """
    pass

BVH_BUILD_STATE_BEGUN = hppfcl.hppfcl.BVHBuildState.BVH_BUILD_STATE_BEGUN
BVH_BUILD_STATE_EMPTY = hppfcl.hppfcl.BVHBuildState.BVH_BUILD_STATE_EMPTY
BVH_BUILD_STATE_PROCESSED = hppfcl.hppfcl.BVHBuildState.BVH_BUILD_STATE_PROCESSED
BVH_BUILD_STATE_REPLACE_BEGUN = hppfcl.hppfcl.BVHBuildState.BVH_BUILD_STATE_REPLACE_BEGUN
BVH_BUILD_STATE_UPDATED = hppfcl.hppfcl.BVHBuildState.BVH_BUILD_STATE_UPDATED
BVH_BUILD_STATE_UPDATE_BEGUN = hppfcl.hppfcl.BVHBuildState.BVH_BUILD_STATE_UPDATE_BEGUN
BVH_MODEL_POINTCLOUD = hppfcl.hppfcl.BVHModelType.BVH_MODEL_POINTCLOUD
BVH_MODEL_TRIANGLES = hppfcl.hppfcl.BVHModelType.BVH_MODEL_TRIANGLES
BVH_MODEL_UNKNOWN = hppfcl.hppfcl.BVHModelType.BVH_MODEL_UNKNOWN
BV_AABB = hppfcl.hppfcl.NODE_TYPE.BV_AABB
BV_KDOP16 = hppfcl.hppfcl.NODE_TYPE.BV_KDOP16
BV_KDOP18 = hppfcl.hppfcl.NODE_TYPE.BV_KDOP18
BV_KDOP24 = hppfcl.hppfcl.NODE_TYPE.BV_KDOP24
BV_OBB = hppfcl.hppfcl.NODE_TYPE.BV_OBB
BV_OBBRSS = hppfcl.hppfcl.NODE_TYPE.BV_OBBRSS
BV_RSS = hppfcl.hppfcl.NODE_TYPE.BV_RSS
BV_UNKNOWN = hppfcl.hppfcl.NODE_TYPE.BV_UNKNOWN
BV_kIOS = hppfcl.hppfcl.NODE_TYPE.BV_kIOS
CONTACT = hppfcl.hppfcl.CollisionRequestFlag.CONTACT
DISTANCE_LOWER_BOUND = hppfcl.hppfcl.CollisionRequestFlag.DISTANCE_LOWER_BOUND
Failed = hppfcl.hppfcl.GJKStatus.Failed
GEOM_BOX = hppfcl.hppfcl.NODE_TYPE.GEOM_BOX
GEOM_CAPSULE = hppfcl.hppfcl.NODE_TYPE.GEOM_CAPSULE
GEOM_CONE = hppfcl.hppfcl.NODE_TYPE.GEOM_CONE
GEOM_CONVEX = hppfcl.hppfcl.NODE_TYPE.GEOM_CONVEX
GEOM_CYLINDER = hppfcl.hppfcl.NODE_TYPE.GEOM_CYLINDER
GEOM_HALFSPACE = hppfcl.hppfcl.NODE_TYPE.GEOM_HALFSPACE
GEOM_OCTREE = hppfcl.hppfcl.NODE_TYPE.GEOM_OCTREE
GEOM_PLANE = hppfcl.hppfcl.NODE_TYPE.GEOM_PLANE
GEOM_SPHERE = hppfcl.hppfcl.NODE_TYPE.GEOM_SPHERE
GEOM_TRIANGLE = hppfcl.hppfcl.NODE_TYPE.GEOM_TRIANGLE
HF_AABB = hppfcl.hppfcl.NODE_TYPE.HF_AABB
HF_OBBRSS = hppfcl.hppfcl.NODE_TYPE.HF_OBBRSS
HPP_FCL_MAJOR_VERSION = 1
HPP_FCL_MINOR_VERSION = 8
HPP_FCL_PATCH_VERSION = 0
Inside = hppfcl.hppfcl.GJKStatus.Inside
NO_REQUEST = hppfcl.hppfcl.CollisionRequestFlag.NO_REQUEST
OT_BVH = hppfcl.hppfcl.OBJECT_TYPE.OT_BVH
OT_GEOM = hppfcl.hppfcl.OBJECT_TYPE.OT_GEOM
OT_HFIELD = hppfcl.hppfcl.OBJECT_TYPE.OT_HFIELD
OT_OCTREE = hppfcl.hppfcl.OBJECT_TYPE.OT_OCTREE
OT_UNKNOWN = hppfcl.hppfcl.OBJECT_TYPE.OT_UNKNOWN
Valid = hppfcl.hppfcl.GJKStatus.Valid
__raw_version__ = '1.8.0'
__version__ = '1.8.0'
checkVersionAtLeast: Boost.Python.function
checkVersionAtMost: Boost.Python.function
collide: Boost.Python.function
computeMemoryFootprint: Boost.Python.function
distance: Boost.Python.function
getNumpyType: Boost.Python.function
makeOctree: Boost.Python.function
rotate: Boost.Python.function
seed: Boost.Python.function
setNumpyType: Boost.Python.function
sharedMemory: Boost.Python.function
switchToNumpyArray: Boost.Python.function
switchToNumpyMatrix: Boost.Python.function
translate: Boost.Python.function
import Boost.Python
import hppfcl.hppfcl

